/*
 * File: Airco.cs
 * Date: 06 aug 2012
 * Time: 11:05:49
 * Generated by TismTool version 0.9
 */

/*
 * Overview of identifications
 * ---------------------------
 * Ports:
 *      5 ( Xmi > Data > Protocols > AircoProtocol > AircoServer > Port )
 *     76 ( Xmi > Data > Protocols > SensorProtocol > SensorClient > Port )
 *    103 ( Xmi > Data > Protocols > SensorProtocol > SensorServer > Port )
 *    136 ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > Port )
 *    157 ( Xmi > Data > Protocols > FanProtocol > FanServer > Port )
 *    192 ( Xmi > Data > Protocols > NvmProtocol > NvmServer > Port )
 *    228 ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > pp_airco )
 *    232 ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_sensor )
 * Triggers:
 *      1 void IAirco___On()
 *      2 void IAirco___Off()
 *      3 FanLevel IAirco___GetLevel()
 *      4 int IAirco___GetTarget()
 *      5 void IAirco___SetTarget( int Target )
 *      6 void IAirco___Start()
 *      7 void IAirco___Stop()
 *      8 void IAirco___FanLow()
 *      9 void IAirco___FanHigh()
 *     10 void ICbSensor___CbAbove()
 *     11 void ICbSensor___CbBelow()
 *     12 void ICbSensor___CbStopped()
 *     13 double ISensor___GetTemperature()
 *     14 void ISensor___SignalAbove( int Target )
 *     15 void ISensor___SignalBelow( int Target )
 *     16 void ISensor___Stop()
 *     17 void ICooler___Start()
 *     18 void ICooler___Stop()
 *     19 void IFan___Stop()
 *     20 void IFan___ToLow()
 *     21 void IFan___ToHigh()
 *     22 int INvm___GetTarget()
 *     23 void INvm___SetTarget( int Target )
 *     24 FanLevel INvm___GetFanLevel()
 *     25 void INvm___SetFanLevel( FanLevel Level )
 * Natives:
 *    -52 ( AircoClientPsm >> Active > Cooler > Outer ) ->
 *        ( AircoClientPsm >> Active > Cooler > Outer )
 *        SetTarget( Target );
 *    -54 ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) ->
 *        ( AircoClientPsm >> Active > Cooler > Outer >> Cooling )
 *        Start();
 *    -55 ( AircoClientPsm >> Active > Cooler > Outer >> Cooling ) ->
 *        ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
 *        Stop();
 *    -56 ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) ->
 *        ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
 *        Target=GetTarget();
 *    -67 ( AircoClientPsm >> Active > Fan > ReportLevel ) ->
 *        ( AircoClientPsm >> Active > Fan > ChoiceState )
 *        Level=GetLevel();
 *    -68 ( AircoClientPsm >> Active > Fan > Low ) ->
 *        ( AircoClientPsm >> Active > Fan > High )
 *        FanHigh();
 *    -69 ( AircoClientPsm >> Active > Fan > High ) ->
 *        ( AircoClientPsm >> Active > Fan > Low )
 *        FanLow();
 *    -72 ( AircoClientPsm >> Standby ) ->
 *        ( AircoClientPsm >> Active )
 *        On();
 *    -73 ( AircoClientPsm >> Active ) ->
 *        ( AircoClientPsm >> Standby )
 *        Off();
 *    -90 ( SensorClientPsm >> Outer >> Inner >> Idle ) ->
 *        ( SensorClientPsm >> Outer >> Inner >> SenseAbove )
 *        SignalAbove( Target );
 *    -92 ( SensorClientPsm >> Outer >> Inner >> Idle ) ->
 *        ( SensorClientPsm >> Outer >> Inner >> SenseBelow )
 *        SignalBelow( Target );
 *    -96 ( SensorClientPsm >> Outer >> Inner ) ->
 *        ( SensorClientPsm >> Outer >> Stopping )
 *        Stop();
 *    -98 ( SensorClientPsm >> Outer ) ->
 *        ( SensorClientPsm >> Outer )
 *        GetTemperature();
 *    118 ( SensorServerPsm >> Outer >> Inner >> SenseAbove ) ->
 *        ( SensorServerPsm >> Outer >> Inner >> Idle )
 *        CbAbove();
 *    120 ( SensorServerPsm >> Outer >> Inner >> SenseBelow ) ->
 *        ( SensorServerPsm >> Outer >> Inner >> Idle )
 *        CbBelow();
 *    124 ( SensorServerPsm >> Outer >> Stopping ) ->
 *        ( SensorServerPsm >> Outer >> Inner )
 *        CbStopped();
 *   -152 ( CoolerClientPsm >> Idle ) ->
 *        ( CoolerClientPsm >> Busy )
 *        Start();
 *   -153 ( CoolerClientPsm >> Busy ) ->
 *        ( CoolerClientPsm >> Idle )
 *        Stop();
 *   -181 ( FanClientPsm >> Busy >> Low ) ->
 *        ( FanClientPsm >> Busy >> High )
 *        ToHigh();
 *   -182 ( FanClientPsm >> Busy >> High ) ->
 *        ( FanClientPsm >> Busy >> Low )
 *        ToLow();
 *   -184 ( FanClientPsm >> Idle ) ->
 *        ( FanClientPsm >> Busy >> Low )
 *        ToLow();
 *   -185 ( FanClientPsm >> Idle ) ->
 *        ( FanClientPsm >> Busy >> High )
 *        ToHigh();
 *   -186 ( FanClientPsm >> Busy ) ->
 *        ( FanClientPsm >> Idle )
 *        Stop();
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TsmRTE;

namespace Airco
{
  public partial class Airco
  {
    static void ArgsHandle( string[] args )
    {
      for ( int i=0; i<args.Length; i++ )
      {
        char [] ca = args[ i ].ToCharArray();
        if ( ( ca.Length >= 2 ) && ( ca[ 0 ] == '-' ) )
        {
          switch ( ca[1] )
          {
          case 'l' :
            if ( ( ca.Length >= 4 ) && ( ca[ 2 ] == '=' ) )
            {
              int ll = Convert.ToInt32( args[ i ].Substring( 3 ) );
              Tsm.SetLogLevel( ll );
            }
            break;
          case 'C' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetLogConsole( ca[ 2 ] == '+' );
            }
            break;
          case 'L' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetLogFile( ca[ 2 ] == '+' );
            }
            break;
          case 'S' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetSeqFile( ca[ 2 ] == '+' );
            }
            break;
          }
        }
      }
    }

    static void Main( string[] args )
    {
      ArgsHandle( args );
      try
      {
        TsmSystem ts = new TsmSystem( null );
        ts.Activate();
        ts.Execute();
        ts.Deactivate();
      }
      catch ( Exception exc )
      {
        Tsm.Log( "*** TsmSystem Exception ***" );
        Tsm.Log( exc.Message );
        Tsm.Log( exc.StackTrace );
      }
    }
  }

  public enum FanLevel
  {
    LOW,
    HIGH
  }

  public interface IAirco
  {
    void On();
    void Off();
    FanLevel GetLevel();
    int GetTarget();
    void SetTarget( int Target );
    void Start();
    void Stop();
    void FanLow();
    void FanHigh();
  }

  public class TsmTrigger_IAirco___On : TsmTrigger
  {
    public TsmTrigger_IAirco___On()
      : base( 1 )
    {
    }
  }

  public class TsmTrigger_IAirco___Off : TsmTrigger
  {
    public TsmTrigger_IAirco___Off()
      : base( 2 )
    {
    }
  }

  public class TsmTrigger_IAirco___GetLevel : TsmTrigger
  {
    public FanLevel _RetVal;

    public TsmTrigger_IAirco___GetLevel()
      : base( 3 )
    {
    }
  }

  public class TsmTrigger_IAirco___GetTarget : TsmTrigger
  {
    public int _RetVal;

    public TsmTrigger_IAirco___GetTarget()
      : base( 4 )
    {
    }
  }

  public class TsmTrigger_IAirco___SetTarget : TsmTrigger
  {
    public int Target;

    public TsmTrigger_IAirco___SetTarget( int Target )
      : base( 5 )
    {
      this.Target = Target;
    }
  }

  public class TsmTrigger_IAirco___Start : TsmTrigger
  {
    public TsmTrigger_IAirco___Start()
      : base( 6 )
    {
    }
  }

  public class TsmTrigger_IAirco___Stop : TsmTrigger
  {
    public TsmTrigger_IAirco___Stop()
      : base( 7 )
    {
    }
  }

  public class TsmTrigger_IAirco___FanLow : TsmTrigger
  {
    public TsmTrigger_IAirco___FanLow()
      : base( 8 )
    {
    }
  }

  public class TsmTrigger_IAirco___FanHigh : TsmTrigger
  {
    public TsmTrigger_IAirco___FanHigh()
      : base( 9 )
    {
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > IAirco )
  public class TsmIPort_IAirco : TsmInterfacePort, IAirco
  {
    public TsmIPort_IAirco( TsmBase oParent )
    {
      TsmName = "IAirco";
      TsmParent = oParent;
    }

    public virtual void On()
    {
      TsmTrigger_IAirco___On tt = new TsmTrigger_IAirco___On();
      TsmRecorder.AddCall( "On", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void Off()
    {
      TsmTrigger_IAirco___Off tt = new TsmTrigger_IAirco___Off();
      TsmRecorder.AddCall( "Off", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual FanLevel GetLevel()
    {
      TsmTrigger_IAirco___GetLevel tt = new TsmTrigger_IAirco___GetLevel();
      TsmRecorder.AddCall( "GetLevel", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
      return tt._RetVal;
    }

    public virtual int GetTarget()
    {
      TsmTrigger_IAirco___GetTarget tt = new TsmTrigger_IAirco___GetTarget();
      TsmRecorder.AddCall( "GetTarget", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
      return tt._RetVal;
    }

    public virtual void SetTarget( int Target )
    {
      TsmTrigger_IAirco___SetTarget tt = new TsmTrigger_IAirco___SetTarget( Target );
      TsmRecorder.AddCall( "SetTarget", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void Start()
    {
      TsmTrigger_IAirco___Start tt = new TsmTrigger_IAirco___Start();
      TsmRecorder.AddCall( "Start", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void Stop()
    {
      TsmTrigger_IAirco___Stop tt = new TsmTrigger_IAirco___Stop();
      TsmRecorder.AddCall( "Stop", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void FanLow()
    {
      TsmTrigger_IAirco___FanLow tt = new TsmTrigger_IAirco___FanLow();
      TsmRecorder.AddCall( "FanLow", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void FanHigh()
    {
      TsmTrigger_IAirco___FanHigh tt = new TsmTrigger_IAirco___FanHigh();
      TsmRecorder.AddCall( "FanHigh", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> InitialState )
  public class Ini_0007_0008 : TsmPseudo
  {
    public Ini_0007_0008( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 36, "( AircoServerPsm >> InitialState ) => ( AircoServerPsm >> Standby )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 36; // TRLS ( AircoServerPsm >> InitialState ) => ( AircoServerPsm >> Standby )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 36: // UP: ( AircoServerPsm >> InitialState ) => ( AircoServerPsm >> Standby )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > InitialState )
  public class Ini_0010_0011 : TsmPseudo
  {
    public Ini_0010_0011( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 22, "( AircoServerPsm >> Active > Cooler > InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 22; // TRLS ( AircoServerPsm >> Active > Cooler > InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 22: // UP: ( AircoServerPsm >> Active > Cooler > InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> InitialState )
  public class Ini_0013_0014 : TsmPseudo
  {
    public Ini_0013_0014( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 18, "( AircoServerPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 18; // TRLS ( AircoServerPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 18: // UP: ( AircoServerPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> Idle )
  public class Lea_0013_0015 : TsmLeaf
  {
    public Lea_0013_0015( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 21, "( AircoServerPsm >> Active > Cooler > Outer >> Idle ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle ) : GetTarget" );
      mTransitions[ 1 ] = new TsmTransition( 19, "( AircoServerPsm >> Active > Cooler > Outer >> Idle ) => ( AircoServerPsm >> Active > Cooler > Outer >> Cooling ) : Start" );
    }

    public void Tra_0013_0018( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0013_0021( TsmHandler oHandler )
    {
      ((Cla_0003_0004)oHandler.Owner).Function_1064( oHandler );
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void Port___GetTarget( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 21; // GetTarget
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Port___Start( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 19; // Start
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public void Tra_0013_0020( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 4:
          return TsmProspect.OK;
        case 6:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 5: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 4: // Port___GetTarget
          {
            Port___GetTarget( oHandler );
          }
          break;
        case 6: // Port___Start
          {
            Port___Start( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 18:
        Tra_0013_0018( oHandler );
        break;
      case 21:
        Tra_0013_0021( oHandler );
        break;
      case 19: // UP: ( AircoServerPsm >> Active > Cooler > Outer >> Idle ) => ( AircoServerPsm >> Active > Cooler > Outer >> Cooling )
        bHigher = true;
        break;
      case 20:
        Tra_0013_0020( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> Cooling )
  public class Lea_0013_0016 : TsmLeaf
  {
    public Lea_0013_0016( TsmBase oParent )
    {
      TsmName = "Cooling";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 20, "( AircoServerPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle ) : Stop" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0013_0019( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___Stop( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 20; // Stop
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 5: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 7: // Port___Stop
          {
            Port___Stop( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 19:
        Tra_0013_0019( oHandler );
        break;
      case 20: // UP: ( AircoServerPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >)
  public class Reg_0012_0013 : TsmRegion
  {
    private Ini_0013_0014 oIni_0013_0014; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> InitialState )
    private Lea_0013_0015 oLea_0013_0015; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> Idle )
    private Lea_0013_0016 oLea_0013_0016; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >> Cooling )

    public Reg_0012_0013( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0013_0014 = new Ini_0013_0014( this );
      oLea_0013_0015 = new Lea_0013_0015( this );
      oLea_0013_0016 = new Lea_0013_0016( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0013_0014;
      mStates[ 1 ] = oLea_0013_0015;
      mStates[ 2 ] = oLea_0013_0016;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0013_0014.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle )
    public void Tra_0013_0018( TsmHandler oHandler )
    {
      mCurrentState = oLea_0013_0015; // At: ( AircoServerPsm >> Active > Cooler > Outer >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Active > Cooler > Outer >> Idle ) => ( AircoServerPsm >> Active > Cooler > Outer >> Cooling )
    public void Tra_0013_0019( TsmHandler oHandler )
    {
      mCurrentState = oLea_0013_0016; // At: ( AircoServerPsm >> Active > Cooler > Outer >> Cooling )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle )
    public void Tra_0013_0020( TsmHandler oHandler )
    {
      mCurrentState = oLea_0013_0015; // At: ( AircoServerPsm >> Active > Cooler > Outer >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 4:
          return TsmProspect.OK;
        case 6:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 18:
        Tra_0013_0018( oHandler );
        break;
      case 19:
        Tra_0013_0019( oHandler );
        break;
      case 20:
        Tra_0013_0020( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer )
  public class Com_0010_0012 : TsmCompound
  {
    private Reg_0012_0013 oReg_0012_0013; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer >)

    public Com_0010_0012( TsmBase oParent )
    {
      TsmName = "Outer";
      TsmParent = oParent;
      oReg_0012_0013 = new Reg_0012_0013( this );
      mRegions.Add( oReg_0012_0013 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 17, "( AircoServerPsm >> Active > Cooler > Outer ) => ( AircoServerPsm >> Active > Cooler > Outer ) : SetTarget" );
    }

    public void Tra_0010_0022( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0013_0017( TsmHandler oHandler )
    {
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Port___SetTarget( int Target, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 17; // SetTarget
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 5:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 5: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 5: // Port___SetTarget
          {
            TsmTrigger_IAirco___SetTarget lTrigger = (TsmTrigger_IAirco___SetTarget) oHandler.Trigger;

            Port___SetTarget( lTrigger.Target, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 22:
        Tra_0010_0022( oHandler );
        break;
      case 17:
        Tra_0013_0017( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler )
  public class Reg_0009_0010 : TsmRegion
  {
    private Ini_0010_0011 oIni_0010_0011; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > InitialState )
    private Com_0010_0012 oCom_0010_0012; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler > Outer )

    public Reg_0009_0010( TsmBase oParent )
    {
      TsmName = "Cooler";
      TsmParent = oParent;
      oIni_0010_0011 = new Ini_0010_0011( this );
      oCom_0010_0012 = new Com_0010_0012( this );
      mNrStates = 2;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0010_0011;
      mStates[ 1 ] = oCom_0010_0012;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0010_0011.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Active > Cooler > InitialState ) => ( AircoServerPsm >> Active > Cooler > Outer )
    public void Tra_0010_0022( TsmHandler oHandler )
    {
      mCurrentState = oCom_0010_0012; // At: ( AircoServerPsm >> Active > Cooler > Outer )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 4:
          return TsmProspect.OK;
        case 5:
          return TsmProspect.OK;
        case 6:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 22:
        Tra_0010_0022( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > InitialState )
  public class Ini_0023_0024 : TsmPseudo
  {
    public Ini_0023_0024( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 31, "( AircoServerPsm >> Active > Fan > InitialState ) => ( AircoServerPsm >> Active > Fan > ReportLevel )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 31; // TRLS ( AircoServerPsm >> Active > Fan > InitialState ) => ( AircoServerPsm >> Active > Fan > ReportLevel )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 31: // UP: ( AircoServerPsm >> Active > Fan > InitialState ) => ( AircoServerPsm >> Active > Fan > ReportLevel )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > ChoiceState )
  public class Cho_0023_0025 : TsmPseudo
  {
    private int MaxNrChoices = 2;

    public Cho_0023_0025( TsmBase oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 29, "( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > Low )" );
      mTransitions[ 1 ] = new TsmTransition( 30, "( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > High )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "low level" ) )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 29; // TRLS ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > Low )
        mTransitions[ 0 ].bVisit = true;
      }
      else
      if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 30; // TRLS ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > High )
        mTransitions[ 1 ].bVisit = true;
      }
    }

    public void Tra_0023_0032( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 29: // UP: ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > Low )
        bHigher = true;
        break;
      case 30: // UP: ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > High )
        bHigher = true;
        break;
      case 32:
        Tra_0023_0032( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > Low )
  public class Lea_0023_0026 : TsmLeaf
  {
    public Lea_0023_0026( TsmBase oParent )
    {
      TsmName = "Low";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 33, "( AircoServerPsm >> Active > Fan > Low ) => ( AircoServerPsm >> Active > Fan > High ) : FanHigh" );
    }

    public void Tra_0023_0029( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0023_0034( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___FanHigh( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 33; // FanHigh
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 5: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 9: // Port___FanHigh
          {
            Port___FanHigh( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 29:
        Tra_0023_0029( oHandler );
        break;
      case 34:
        Tra_0023_0034( oHandler );
        break;
      case 33: // UP: ( AircoServerPsm >> Active > Fan > Low ) => ( AircoServerPsm >> Active > Fan > High )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > High )
  public class Lea_0023_0027 : TsmLeaf
  {
    public Lea_0023_0027( TsmBase oParent )
    {
      TsmName = "High";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 34, "( AircoServerPsm >> Active > Fan > High ) => ( AircoServerPsm >> Active > Fan > Low ) : FanLow" );
    }

    public void Tra_0023_0030( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Port___FanLow( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 34; // FanLow
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0023_0033( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 8:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 5: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 8: // Port___FanLow
          {
            Port___FanLow( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 30:
        Tra_0023_0030( oHandler );
        break;
      case 34: // UP: ( AircoServerPsm >> Active > Fan > High ) => ( AircoServerPsm >> Active > Fan > Low )
        bHigher = true;
        break;
      case 33:
        Tra_0023_0033( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > ReportLevel )
  public class Lea_0023_0028 : TsmLeaf
  {
    public Lea_0023_0028( TsmBase oParent )
    {
      TsmName = "ReportLevel";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 32, "( AircoServerPsm >> Active > Fan > ReportLevel ) => ( AircoServerPsm >> Active > Fan > ChoiceState ) : GetLevel" );
    }

    public void Tra_0023_0031( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Port___GetLevel( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 32; // GetLevel
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 5: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 3: // Port___GetLevel
          {
            Port___GetLevel( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 31:
        Tra_0023_0031( oHandler );
        break;
      case 32: // UP: ( AircoServerPsm >> Active > Fan > ReportLevel ) => ( AircoServerPsm >> Active > Fan > ChoiceState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan )
  public class Reg_0009_0023 : TsmRegion
  {
    private Ini_0023_0024 oIni_0023_0024; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > InitialState )
    private Cho_0023_0025 oCho_0023_0025; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > ChoiceState )
    private Lea_0023_0026 oLea_0023_0026; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > Low )
    private Lea_0023_0027 oLea_0023_0027; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > High )
    private Lea_0023_0028 oLea_0023_0028; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan > ReportLevel )

    public Reg_0009_0023( TsmBase oParent )
    {
      TsmName = "Fan";
      TsmParent = oParent;
      oIni_0023_0024 = new Ini_0023_0024( this );
      oCho_0023_0025 = new Cho_0023_0025( this );
      oLea_0023_0026 = new Lea_0023_0026( this );
      oLea_0023_0027 = new Lea_0023_0027( this );
      oLea_0023_0028 = new Lea_0023_0028( this );
      mNrStates = 5;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0023_0024;
      mStates[ 1 ] = oCho_0023_0025;
      mStates[ 2 ] = oLea_0023_0026;
      mStates[ 3 ] = oLea_0023_0027;
      mStates[ 4 ] = oLea_0023_0028;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0023_0024.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Active > Fan > InitialState ) => ( AircoServerPsm >> Active > Fan > ReportLevel )
    public void Tra_0023_0031( TsmHandler oHandler )
    {
      mCurrentState = oLea_0023_0028; // At: ( AircoServerPsm >> Active > Fan > ReportLevel )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > Low )
    public void Tra_0023_0029( TsmHandler oHandler )
    {
      ((Cla_0003_0004)oHandler.Owner).Function_1002( oHandler );
      mCurrentState = oLea_0023_0026; // At: ( AircoServerPsm >> Active > Fan > Low )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > High )
    public void Tra_0023_0030( TsmHandler oHandler )
    {
      ((Cla_0003_0004)oHandler.Owner).Function_1004( oHandler );
      mCurrentState = oLea_0023_0027; // At: ( AircoServerPsm >> Active > Fan > High )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Active > Fan > ReportLevel ) => ( AircoServerPsm >> Active > Fan > ChoiceState )
    public void Tra_0023_0032( TsmHandler oHandler )
    {
      mCurrentState = oCho_0023_0025; // At: ( AircoServerPsm >> Active > Fan > ChoiceState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Active > Fan > High ) => ( AircoServerPsm >> Active > Fan > Low )
    public void Tra_0023_0034( TsmHandler oHandler )
    {
      mCurrentState = oLea_0023_0026; // At: ( AircoServerPsm >> Active > Fan > Low )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Active > Fan > Low ) => ( AircoServerPsm >> Active > Fan > High )
    public void Tra_0023_0033( TsmHandler oHandler )
    {
      mCurrentState = oLea_0023_0027; // At: ( AircoServerPsm >> Active > Fan > High )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        case 8:
          return TsmProspect.OK;
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 31:
        Tra_0023_0031( oHandler );
        break;
      case 29:
        Tra_0023_0029( oHandler );
        break;
      case 30:
        Tra_0023_0030( oHandler );
        break;
      case 32:
        Tra_0023_0032( oHandler );
        break;
      case 34:
        Tra_0023_0034( oHandler );
        break;
      case 33:
        Tra_0023_0033( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active )
  public class Com_0007_0009 : TsmCompound
  {
    private Reg_0009_0010 oReg_0009_0010; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Cooler )
    private Reg_0009_0023 oReg_0009_0023; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active > Fan )

    public Com_0007_0009( TsmBase oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0009_0010 = new Reg_0009_0010( this );
      oReg_0009_0023 = new Reg_0009_0023( this );
      mRegions.Add( oReg_0009_0010 );
      mRegions.Add( oReg_0009_0023 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 38, "( AircoServerPsm >> Active ) => ( AircoServerPsm >> Standby ) : Off" );
    }

    public void Tra_0007_0037( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___Off( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 38; // Off
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 5: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 2: // Port___Off
          {
            Port___Off( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 37:
        Tra_0007_0037( oHandler );
        break;
      case 38: // UP: ( AircoServerPsm >> Active ) => ( AircoServerPsm >> Standby )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Standby )
  public class Lea_0007_0035 : TsmLeaf
  {
    public Lea_0007_0035( TsmBase oParent )
    {
      TsmName = "Standby";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 37, "( AircoServerPsm >> Standby ) => ( AircoServerPsm >> Active ) : On" );
    }

    public void Tra_0007_0036( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Port___On( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 37; // On
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0007_0038( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 5: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 1: // Port___On
          {
            Port___On( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 36:
        Tra_0007_0036( oHandler );
        break;
      case 37: // UP: ( AircoServerPsm >> Standby ) => ( AircoServerPsm >> Active )
        bHigher = true;
        break;
      case 38:
        Tra_0007_0038( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >)
  public class Reg_0006_0007 : TsmRegion
  {
    private Ini_0007_0008 oIni_0007_0008; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> InitialState )
    private Com_0007_0009 oCom_0007_0009; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Active )
    private Lea_0007_0035 oLea_0007_0035; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >> Standby )

    public Reg_0006_0007( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0007_0008 = new Ini_0007_0008( this );
      oCom_0007_0009 = new Com_0007_0009( this );
      oLea_0007_0035 = new Lea_0007_0035( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0007_0008;
      mStates[ 1 ] = oCom_0007_0009;
      mStates[ 2 ] = oLea_0007_0035;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0007_0008.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> InitialState ) => ( AircoServerPsm >> Standby )
    public void Tra_0007_0036( TsmHandler oHandler )
    {
      mCurrentState = oLea_0007_0035; // At: ( AircoServerPsm >> Standby )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Standby ) => ( AircoServerPsm >> Active )
    public void Tra_0007_0037( TsmHandler oHandler )
    {
      mCurrentState = oCom_0007_0009; // At: ( AircoServerPsm >> Active )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoServerPsm >> Active ) => ( AircoServerPsm >> Standby )
    public void Tra_0007_0038( TsmHandler oHandler )
    {
      mCurrentState = oLea_0007_0035; // At: ( AircoServerPsm >> Standby )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 5:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        case 2:
          return TsmProspect.OK;
        case 3:
          return TsmProspect.OK;
        case 4:
          return TsmProspect.OK;
        case 5:
          return TsmProspect.OK;
        case 6:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        case 8:
          return TsmProspect.OK;
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 36:
        Tra_0007_0036( oHandler );
        break;
      case 37:
        Tra_0007_0037( oHandler );
        break;
      case 38:
        Tra_0007_0038( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm )
  public class Fsm_0004_0006 : TsmFsm
  {
    private Reg_0006_0007 oReg_0006_0007; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm >)

    public Fsm_0004_0006( TsmBase oParent )
    {
      TsmName = "AircoServerPsm";
      TsmParent = oParent;
      oReg_0006_0007 = new Reg_0006_0007( this );
      mRegions.Add( oReg_0006_0007 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoServer )
  public class Cla_0003_0004 : TsmProtocolClass
  {
    private Fsm_0004_0006 oFsm_0004_0006; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > AircoServerPsm )
    private TsmIPort_IAirco TsmPI__Port; // ( Xmi > Data > Protocols > AircoProtocol > AircoServer > Port )
    private TsmPSPort mPSMessager;
    private int MyTarget = 21;

    public Cla_0003_0004( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0004_0006 = new Fsm_0004_0006( this );
      TsmPI__Port = new TsmIPort_IAirco( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0004_0006;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > AircoProtocol > AircoServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0004_0006.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > Low )
    public FanLevel Function_1001()
    {
      return FanLevel.LOW;
    }

     // ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > Low )
    public void Function_1002( TsmHandler oHandler )
    {
      TsmTrigger_IAirco___GetLevel lTrigger = (TsmTrigger_IAirco___GetLevel) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0003_0004)oHandler.Owner).Function_1001();
    }

     // ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > High )
    public FanLevel Function_1003()
    {
      return FanLevel.HIGH;
    }

     // ( AircoServerPsm >> Active > Fan > ChoiceState ) => ( AircoServerPsm >> Active > Fan > High )
    public void Function_1004( TsmHandler oHandler )
    {
      TsmTrigger_IAirco___GetLevel lTrigger = (TsmTrigger_IAirco___GetLevel) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0003_0004)oHandler.Owner).Function_1003();
    }

     // ( AircoServerPsm >> Active > Cooler > Outer >> Idle ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle )
    public int Function_1063()
    {
      return MyTarget;
    }

     // ( AircoServerPsm >> Active > Cooler > Outer >> Idle ) => ( AircoServerPsm >> Active > Cooler > Outer >> Idle )
    public void Function_1064( TsmHandler oHandler )
    {
      TsmTrigger_IAirco___GetTarget lTrigger = (TsmTrigger_IAirco___GetTarget) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0003_0004)oHandler.Owner).Function_1063();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 5;
      TsmPI__Port.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0004_0006.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> InitialState )
  public class Ini_0042_0043 : TsmPseudo
  {
    public Ini_0042_0043( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 71, "( AircoClientPsm >> InitialState ) => ( AircoClientPsm >> Standby )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 71; // TRLS ( AircoClientPsm >> InitialState ) => ( AircoClientPsm >> Standby )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 71: // UP: ( AircoClientPsm >> InitialState ) => ( AircoClientPsm >> Standby )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > InitialState )
  public class Ini_0045_0046 : TsmPseudo
  {
    public Ini_0045_0046( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 57, "( AircoClientPsm >> Active > Cooler > InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 57; // TRLS ( AircoClientPsm >> Active > Cooler > InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 57: // UP: ( AircoClientPsm >> Active > Cooler > InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> InitialState )
  public class Ini_0048_0049 : TsmPseudo
  {
    public Ini_0048_0049( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 53, "( AircoClientPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 53; // TRLS ( AircoClientPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 53: // UP: ( AircoClientPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> Idle )
  public class Lea_0048_0050 : TsmLeaf
  {
    int [] aNatives = { -54, -56 };

    public Lea_0048_0050( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 54, "( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Cooling )" );
      mTransitions[ 1 ] = new TsmTransition( 56, "( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )" );
    }

    public void Tra_0048_0053( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0048_0056( TsmHandler oHandler )
    {
      AtExit( oHandler );
      ((Cla_0003_0039)oHandler.Owner).Function_1043( oHandler );
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void Tra_0048_0055( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 54:
          return TsmProspect.OK;
        case 56:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 54: // Native: ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Cooling )
          TsmRecorder.AddNative( "( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Cooling ) # Start();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 54;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        case 56: // Native: ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
          TsmRecorder.AddNative( "( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) # Target=GetTarget();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 56;
          oHandler.bTaken = true;
          mTransitions[ 1 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 53:
        Tra_0048_0053( oHandler );
        break;
      case 54: // UP: ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Cooling )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 56:
        Tra_0048_0056( oHandler );
        break;
      case 55:
        Tra_0048_0055( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> Cooling )
  public class Lea_0048_0051 : TsmLeaf
  {
    int [] aNatives = { -55 };

    public Lea_0048_0051( TsmBase oParent )
    {
      TsmName = "Cooling";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 55, "( AircoClientPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0048_0054( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 55:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 55: // Native: ( AircoClientPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
          TsmRecorder.AddNative( "( AircoClientPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) # Stop();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 55;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 54:
        Tra_0048_0054( oHandler );
        break;
      case 55: // UP: ( AircoClientPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >)
  public class Reg_0047_0048 : TsmRegion
  {
    private Ini_0048_0049 oIni_0048_0049; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> InitialState )
    private Lea_0048_0050 oLea_0048_0050; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> Idle )
    private Lea_0048_0051 oLea_0048_0051; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >> Cooling )

    public Reg_0047_0048( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0048_0049 = new Ini_0048_0049( this );
      oLea_0048_0050 = new Lea_0048_0050( this );
      oLea_0048_0051 = new Lea_0048_0051( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0048_0049;
      mStates[ 1 ] = oLea_0048_0050;
      mStates[ 2 ] = oLea_0048_0051;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0048_0049.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Active > Cooler > Outer >> InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
    public void Tra_0048_0053( TsmHandler oHandler )
    {
      mCurrentState = oLea_0048_0050; // At: ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Cooling )
    public void Tra_0048_0054( TsmHandler oHandler )
    {
      ((Cla_0003_0039)oHandler.Owner).Function_1042( oHandler );
      mCurrentState = oLea_0048_0051; // At: ( AircoClientPsm >> Active > Cooler > Outer >> Cooling )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
    public void Tra_0048_0055( TsmHandler oHandler )
    {
      ((Cla_0003_0039)oHandler.Owner).Function_1044( oHandler );
      mCurrentState = oLea_0048_0050; // At: ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 54:
          return TsmProspect.OK;
        case 56:
          return TsmProspect.OK;
        case 55:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 53:
        Tra_0048_0053( oHandler );
        break;
      case 54:
        Tra_0048_0054( oHandler );
        break;
      case 55:
        Tra_0048_0055( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer )
  public class Com_0045_0047 : TsmCompound
  {
    int [] aNatives = { -52 };
    private Reg_0047_0048 oReg_0047_0048; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer >)

    public Com_0045_0047( TsmBase oParent )
    {
      TsmName = "Outer";
      TsmParent = oParent;
      oReg_0047_0048 = new Reg_0047_0048( this );
      mRegions.Add( oReg_0047_0048 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 52, "( AircoClientPsm >> Active > Cooler > Outer ) => ( AircoClientPsm >> Active > Cooler > Outer )" );
    }

    public void Tra_0045_0057( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0048_0052( TsmHandler oHandler )
    {
      ((Cla_0003_0039)oHandler.Owner).Function_1041( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.OK;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtMyExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 52:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 52: // Native: ( AircoClientPsm >> Active > Cooler > Outer ) => ( AircoClientPsm >> Active > Cooler > Outer )
          TsmRecorder.AddNative( "( AircoClientPsm >> Active > Cooler > Outer ) => ( AircoClientPsm >> Active > Cooler > Outer ) # SetTarget( Target );" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 52;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 57:
        Tra_0045_0057( oHandler );
        break;
      case 52:
        Tra_0048_0052( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler )
  public class Reg_0044_0045 : TsmRegion
  {
    private Ini_0045_0046 oIni_0045_0046; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > InitialState )
    private Com_0045_0047 oCom_0045_0047; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler > Outer )

    public Reg_0044_0045( TsmBase oParent )
    {
      TsmName = "Cooler";
      TsmParent = oParent;
      oIni_0045_0046 = new Ini_0045_0046( this );
      oCom_0045_0047 = new Com_0045_0047( this );
      mNrStates = 2;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0045_0046;
      mStates[ 1 ] = oCom_0045_0047;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0045_0046.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Active > Cooler > InitialState ) => ( AircoClientPsm >> Active > Cooler > Outer )
    public void Tra_0045_0057( TsmHandler oHandler )
    {
      mCurrentState = oCom_0045_0047; // At: ( AircoClientPsm >> Active > Cooler > Outer )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 52:
          return TsmProspect.OK;
        case 54:
          return TsmProspect.OK;
        case 56:
          return TsmProspect.OK;
        case 55:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 57:
        Tra_0045_0057( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > InitialState )
  public class Ini_0058_0059 : TsmPseudo
  {
    public Ini_0058_0059( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 66, "( AircoClientPsm >> Active > Fan > InitialState ) => ( AircoClientPsm >> Active > Fan > ReportLevel )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 66; // TRLS ( AircoClientPsm >> Active > Fan > InitialState ) => ( AircoClientPsm >> Active > Fan > ReportLevel )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 66: // UP: ( AircoClientPsm >> Active > Fan > InitialState ) => ( AircoClientPsm >> Active > Fan > ReportLevel )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > ChoiceState )
  public class Cho_0058_0060 : TsmPseudo
  {
    public Cho_0058_0060( TsmBase oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 64, "( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > Low )" );
      mTransitions[ 1 ] = new TsmTransition( 65, "( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > High )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      if ( ((Cla_0003_0039)oHandler.Owner).Guard_1005() )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 64; // TRLS ( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > Low )
        mTransitions[ 0 ].bVisit = true;
      }
      else
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 65; // TRLS ( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > High )
        mTransitions[ 1 ].bVisit = true;
      }
    }

    public void Tra_0058_0067( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 64: // UP: ( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > Low )
        bHigher = true;
        break;
      case 65: // UP: ( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > High )
        bHigher = true;
        break;
      case 67:
        Tra_0058_0067( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > Low )
  public class Lea_0058_0061 : TsmLeaf
  {
    int [] aNatives = { -68 };

    public Lea_0058_0061( TsmBase oParent )
    {
      TsmName = "Low";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 68, "( AircoClientPsm >> Active > Fan > Low ) => ( AircoClientPsm >> Active > Fan > High )" );
    }

    public void Tra_0058_0064( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0058_0069( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 68:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 68: // Native: ( AircoClientPsm >> Active > Fan > Low ) => ( AircoClientPsm >> Active > Fan > High )
          TsmRecorder.AddNative( "( AircoClientPsm >> Active > Fan > Low ) => ( AircoClientPsm >> Active > Fan > High ) # FanHigh();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 68;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 64:
        Tra_0058_0064( oHandler );
        break;
      case 68: // UP: ( AircoClientPsm >> Active > Fan > Low ) => ( AircoClientPsm >> Active > Fan > High )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 69:
        Tra_0058_0069( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > High )
  public class Lea_0058_0062 : TsmLeaf
  {
    int [] aNatives = { -69 };

    public Lea_0058_0062( TsmBase oParent )
    {
      TsmName = "High";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 69, "( AircoClientPsm >> Active > Fan > High ) => ( AircoClientPsm >> Active > Fan > Low )" );
    }

    public void Tra_0058_0065( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0058_0068( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 69:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 69: // Native: ( AircoClientPsm >> Active > Fan > High ) => ( AircoClientPsm >> Active > Fan > Low )
          TsmRecorder.AddNative( "( AircoClientPsm >> Active > Fan > High ) => ( AircoClientPsm >> Active > Fan > Low ) # FanLow();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 69;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 65:
        Tra_0058_0065( oHandler );
        break;
      case 68:
        Tra_0058_0068( oHandler );
        break;
      case 69: // UP: ( AircoClientPsm >> Active > Fan > High ) => ( AircoClientPsm >> Active > Fan > Low )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > ReportLevel )
  public class Lea_0058_0063 : TsmLeaf
  {
    int [] aNatives = { -67 };

    public Lea_0058_0063( TsmBase oParent )
    {
      TsmName = "ReportLevel";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 67, "( AircoClientPsm >> Active > Fan > ReportLevel ) => ( AircoClientPsm >> Active > Fan > ChoiceState )" );
    }

    public void Tra_0058_0066( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 67:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 67: // Native: ( AircoClientPsm >> Active > Fan > ReportLevel ) => ( AircoClientPsm >> Active > Fan > ChoiceState )
          TsmRecorder.AddNative( "( AircoClientPsm >> Active > Fan > ReportLevel ) => ( AircoClientPsm >> Active > Fan > ChoiceState ) # Level=GetLevel();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 67;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 66:
        Tra_0058_0066( oHandler );
        break;
      case 67: // UP: ( AircoClientPsm >> Active > Fan > ReportLevel ) => ( AircoClientPsm >> Active > Fan > ChoiceState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan )
  public class Reg_0044_0058 : TsmRegion
  {
    private Ini_0058_0059 oIni_0058_0059; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > InitialState )
    private Cho_0058_0060 oCho_0058_0060; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > ChoiceState )
    private Lea_0058_0061 oLea_0058_0061; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > Low )
    private Lea_0058_0062 oLea_0058_0062; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > High )
    private Lea_0058_0063 oLea_0058_0063; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan > ReportLevel )

    public Reg_0044_0058( TsmBase oParent )
    {
      TsmName = "Fan";
      TsmParent = oParent;
      oIni_0058_0059 = new Ini_0058_0059( this );
      oCho_0058_0060 = new Cho_0058_0060( this );
      oLea_0058_0061 = new Lea_0058_0061( this );
      oLea_0058_0062 = new Lea_0058_0062( this );
      oLea_0058_0063 = new Lea_0058_0063( this );
      mNrStates = 5;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0058_0059;
      mStates[ 1 ] = oCho_0058_0060;
      mStates[ 2 ] = oLea_0058_0061;
      mStates[ 3 ] = oLea_0058_0062;
      mStates[ 4 ] = oLea_0058_0063;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0058_0059.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Active > Fan > InitialState ) => ( AircoClientPsm >> Active > Fan > ReportLevel )
    public void Tra_0058_0066( TsmHandler oHandler )
    {
      mCurrentState = oLea_0058_0063; // At: ( AircoClientPsm >> Active > Fan > ReportLevel )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > Low )
    public void Tra_0058_0064( TsmHandler oHandler )
    {
      mCurrentState = oLea_0058_0061; // At: ( AircoClientPsm >> Active > Fan > Low )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Active > Fan > ChoiceState ) => ( AircoClientPsm >> Active > Fan > High )
    public void Tra_0058_0065( TsmHandler oHandler )
    {
      mCurrentState = oLea_0058_0062; // At: ( AircoClientPsm >> Active > Fan > High )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Active > Fan > Low ) => ( AircoClientPsm >> Active > Fan > High )
    public void Tra_0058_0068( TsmHandler oHandler )
    {
      ((Cla_0003_0039)oHandler.Owner).Function_1045( oHandler );
      mCurrentState = oLea_0058_0062; // At: ( AircoClientPsm >> Active > Fan > High )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Active > Fan > High ) => ( AircoClientPsm >> Active > Fan > Low )
    public void Tra_0058_0069( TsmHandler oHandler )
    {
      ((Cla_0003_0039)oHandler.Owner).Function_1046( oHandler );
      mCurrentState = oLea_0058_0061; // At: ( AircoClientPsm >> Active > Fan > Low )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Active > Fan > ReportLevel ) => ( AircoClientPsm >> Active > Fan > ChoiceState )
    public void Tra_0058_0067( TsmHandler oHandler )
    {
      ((Cla_0003_0039)oHandler.Owner).Function_1047( oHandler );
      mCurrentState = oCho_0058_0060; // At: ( AircoClientPsm >> Active > Fan > ChoiceState )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 68:
          return TsmProspect.OK;
        case 69:
          return TsmProspect.OK;
        case 67:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 66:
        Tra_0058_0066( oHandler );
        break;
      case 64:
        Tra_0058_0064( oHandler );
        break;
      case 65:
        Tra_0058_0065( oHandler );
        break;
      case 68:
        Tra_0058_0068( oHandler );
        break;
      case 69:
        Tra_0058_0069( oHandler );
        break;
      case 67:
        Tra_0058_0067( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active )
  public class Com_0042_0044 : TsmCompound
  {
    int [] aNatives = { -73 };
    private Reg_0044_0045 oReg_0044_0045; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Cooler )
    private Reg_0044_0058 oReg_0044_0058; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active > Fan )

    public Com_0042_0044( TsmBase oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0044_0045 = new Reg_0044_0045( this );
      oReg_0044_0058 = new Reg_0044_0058( this );
      mRegions.Add( oReg_0044_0045 );
      mRegions.Add( oReg_0044_0058 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 73, "( AircoClientPsm >> Active ) => ( AircoClientPsm >> Standby )" );
    }

    public void Tra_0042_0072( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtMyExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 73:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 73: // Native: ( AircoClientPsm >> Active ) => ( AircoClientPsm >> Standby )
          TsmRecorder.AddNative( "( AircoClientPsm >> Active ) => ( AircoClientPsm >> Standby ) # Off();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 73;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 73: // UP: ( AircoClientPsm >> Active ) => ( AircoClientPsm >> Standby )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 72:
        Tra_0042_0072( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Standby )
  public class Lea_0042_0070 : TsmLeaf
  {
    int [] aNatives = { -72 };

    public Lea_0042_0070( TsmBase oParent )
    {
      TsmName = "Standby";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 72, "( AircoClientPsm >> Standby ) => ( AircoClientPsm >> Active )" );
    }

    public void Tra_0042_0071( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0042_0073( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 72:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 72: // Native: ( AircoClientPsm >> Standby ) => ( AircoClientPsm >> Active )
          TsmRecorder.AddNative( "( AircoClientPsm >> Standby ) => ( AircoClientPsm >> Active ) # On();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 72;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 71:
        Tra_0042_0071( oHandler );
        break;
      case 73:
        Tra_0042_0073( oHandler );
        break;
      case 72: // UP: ( AircoClientPsm >> Standby ) => ( AircoClientPsm >> Active )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >)
  public class Reg_0041_0042 : TsmRegion
  {
    private Ini_0042_0043 oIni_0042_0043; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> InitialState )
    private Com_0042_0044 oCom_0042_0044; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Active )
    private Lea_0042_0070 oLea_0042_0070; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >> Standby )

    public Reg_0041_0042( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0042_0043 = new Ini_0042_0043( this );
      oCom_0042_0044 = new Com_0042_0044( this );
      oLea_0042_0070 = new Lea_0042_0070( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0042_0043;
      mStates[ 1 ] = oCom_0042_0044;
      mStates[ 2 ] = oLea_0042_0070;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0042_0043.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> InitialState ) => ( AircoClientPsm >> Standby )
    public void Tra_0042_0071( TsmHandler oHandler )
    {
      mCurrentState = oLea_0042_0070; // At: ( AircoClientPsm >> Standby )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Active ) => ( AircoClientPsm >> Standby )
    public void Tra_0042_0073( TsmHandler oHandler )
    {
      ((Cla_0003_0039)oHandler.Owner).Function_1040( oHandler );
      mCurrentState = oLea_0042_0070; // At: ( AircoClientPsm >> Standby )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoClientPsm >> Standby ) => ( AircoClientPsm >> Active )
    public void Tra_0042_0072( TsmHandler oHandler )
    {
      ((Cla_0003_0039)oHandler.Owner).Function_1048( oHandler );
      mCurrentState = oCom_0042_0044; // At: ( AircoClientPsm >> Active )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 73:
          return TsmProspect.OK;
        case 52:
          return TsmProspect.OK;
        case 54:
          return TsmProspect.OK;
        case 56:
          return TsmProspect.OK;
        case 55:
          return TsmProspect.OK;
        case 68:
          return TsmProspect.OK;
        case 69:
          return TsmProspect.OK;
        case 67:
          return TsmProspect.OK;
        case 72:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 71:
        Tra_0042_0071( oHandler );
        break;
      case 73:
        Tra_0042_0073( oHandler );
        break;
      case 72:
        Tra_0042_0072( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm )
  public class Fsm_0039_0041 : TsmFsm
  {
    private Reg_0041_0042 oReg_0041_0042; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm >)

    public Fsm_0039_0041( TsmBase oParent )
    {
      TsmName = "AircoClientPsm";
      TsmParent = oParent;
      oReg_0041_0042 = new Reg_0041_0042( this );
      mRegions.Add( oReg_0041_0042 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > AircoProtocol > AircoClient )
  public class Cla_0003_0039 : TsmProtocolClass
  {
    private Fsm_0039_0041 oFsm_0039_0041; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > AircoClientPsm )
    private TsmIPort_IAirco Port; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > Port )
    private FanLevel Level;
    private int Target = 20;

    public Cla_0003_0039( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0039_0041 = new Fsm_0039_0041( this );
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0039_0041;
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_IAirco) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > AircoProtocol > AircoClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0039_0041.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

    public bool Guard_1005()
    {
      return Level==FanLevel.LOW;
    }

     // ( AircoClientPsm >> Active ) => ( AircoClientPsm >> Standby )
    public void Function_1040( TsmHandler oHandler )
    {
      Port.Off();
    }

     // ( AircoClientPsm >> Active > Cooler > Outer ) => ( AircoClientPsm >> Active > Cooler > Outer )
    public void Function_1041( TsmHandler oHandler )
    {
      Port.SetTarget( Target );
    }

     // ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Cooling )
    public void Function_1042( TsmHandler oHandler )
    {
      Port.Start();
    }

     // ( AircoClientPsm >> Active > Cooler > Outer >> Idle ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
    public void Function_1043( TsmHandler oHandler )
    {
      Target=Port.GetTarget();
    }

     // ( AircoClientPsm >> Active > Cooler > Outer >> Cooling ) => ( AircoClientPsm >> Active > Cooler > Outer >> Idle )
    public void Function_1044( TsmHandler oHandler )
    {
      Port.Stop();
    }

     // ( AircoClientPsm >> Active > Fan > Low ) => ( AircoClientPsm >> Active > Fan > High )
    public void Function_1045( TsmHandler oHandler )
    {
      Port.FanHigh();
    }

     // ( AircoClientPsm >> Active > Fan > High ) => ( AircoClientPsm >> Active > Fan > Low )
    public void Function_1046( TsmHandler oHandler )
    {
      Port.FanLow();
    }

     // ( AircoClientPsm >> Active > Fan > ReportLevel ) => ( AircoClientPsm >> Active > Fan > ChoiceState )
    public void Function_1047( TsmHandler oHandler )
    {
      Level=Port.GetLevel();
    }

     // ( AircoClientPsm >> Standby ) => ( AircoClientPsm >> Active )
    public void Function_1048( TsmHandler oHandler )
    {
      Port.On();
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0039_0041.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > AircoProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > AircoProtocol )
  public class Pac_0002_0003 : TsmPackage
  {
    public Pac_0002_0003( TsmBase oParent )
    {
      TsmName = "AircoProtocol";
      TsmParent = oParent;
    }
  }

  public interface ISensor
  {
    double GetTemperature();
    void SignalAbove( int Target );
    void SignalBelow( int Target );
    void Stop();
  }

  public class TsmTrigger_ISensor___GetTemperature : TsmTrigger
  {
    public double _RetVal;

    public TsmTrigger_ISensor___GetTemperature()
      : base( 13 )
    {
    }
  }

  public class TsmTrigger_ISensor___SignalAbove : TsmTrigger
  {
    public int Target;

    public TsmTrigger_ISensor___SignalAbove( int Target )
      : base( 14 )
    {
      this.Target = Target;
    }
  }

  public class TsmTrigger_ISensor___SignalBelow : TsmTrigger
  {
    public int Target;

    public TsmTrigger_ISensor___SignalBelow( int Target )
      : base( 15 )
    {
      this.Target = Target;
    }
  }

  public class TsmTrigger_ISensor___Stop : TsmTrigger
  {
    public TsmTrigger_ISensor___Stop()
      : base( 16 )
    {
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > ISensor )
  public class TsmIPort_ISensor : TsmInterfacePort, ISensor
  {
    public TsmIPort_ISensor( TsmBase oParent )
    {
      TsmName = "ISensor";
      TsmParent = oParent;
    }

    public virtual double GetTemperature()
    {
      TsmTrigger_ISensor___GetTemperature tt = new TsmTrigger_ISensor___GetTemperature();
      TsmRecorder.AddCall( "GetTemperature", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
      return tt._RetVal;
    }

    public virtual void SignalAbove( int Target )
    {
      TsmTrigger_ISensor___SignalAbove tt = new TsmTrigger_ISensor___SignalAbove( Target );
      TsmRecorder.AddCall( "SignalAbove", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void SignalBelow( int Target )
    {
      TsmTrigger_ISensor___SignalBelow tt = new TsmTrigger_ISensor___SignalBelow( Target );
      TsmRecorder.AddCall( "SignalBelow", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void Stop()
    {
      TsmTrigger_ISensor___Stop tt = new TsmTrigger_ISensor___Stop();
      TsmRecorder.AddCall( "Stop", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

  public interface ICbSensor
  {
    void CbAbove();
    void CbBelow();
    void CbStopped();
  }

  public class TsmTrigger_ICbSensor___CbAbove : TsmTrigger
  {
    public TsmTrigger_ICbSensor___CbAbove()
      : base( 10 )
    {
    }
  }

  public class TsmTrigger_ICbSensor___CbBelow : TsmTrigger
  {
    public TsmTrigger_ICbSensor___CbBelow()
      : base( 11 )
    {
    }
  }

  public class TsmTrigger_ICbSensor___CbStopped : TsmTrigger
  {
    public TsmTrigger_ICbSensor___CbStopped()
      : base( 12 )
    {
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > ICbSensor )
  public class TsmIPort_ICbSensor : TsmInterfacePort, ICbSensor
  {
    public TsmIPort_ICbSensor( TsmBase oParent )
    {
      TsmName = "ICbSensor";
      TsmParent = oParent;
    }

    public virtual void CbAbove()
    {
      TsmTrigger_ICbSensor___CbAbove tt = new TsmTrigger_ICbSensor___CbAbove();
      TsmRecorder.AddCall( "CbAbove", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void CbBelow()
    {
      TsmTrigger_ICbSensor___CbBelow tt = new TsmTrigger_ICbSensor___CbBelow();
      TsmRecorder.AddCall( "CbBelow", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void CbStopped()
    {
      TsmTrigger_ICbSensor___CbStopped tt = new TsmTrigger_ICbSensor___CbStopped();
      TsmRecorder.AddCall( "CbStopped", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> InitialState )
  public class Ini_0078_0079 : TsmPseudo
  {
    public Ini_0078_0079( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 101, "( SensorClientPsm >> InitialState ) => ( SensorClientPsm >> Outer )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 101; // TRLS ( SensorClientPsm >> InitialState ) => ( SensorClientPsm >> Outer )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 101: // UP: ( SensorClientPsm >> InitialState ) => ( SensorClientPsm >> Outer )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> InitialState )
  public class Ini_0081_0082 : TsmPseudo
  {
    public Ini_0081_0082( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 95, "( SensorClientPsm >> Outer >> InitialState ) => ( SensorClientPsm >> Outer >> Inner )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 95; // TRLS ( SensorClientPsm >> Outer >> InitialState ) => ( SensorClientPsm >> Outer >> Inner )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 95: // UP: ( SensorClientPsm >> Outer >> InitialState ) => ( SensorClientPsm >> Outer >> Inner )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> InitialState )
  public class Ini_0084_0085 : TsmPseudo
  {
    public Ini_0084_0085( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 89, "( SensorClientPsm >> Outer >> Inner >> InitialState ) => ( SensorClientPsm >> Outer >> Inner >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 89; // TRLS ( SensorClientPsm >> Outer >> Inner >> InitialState ) => ( SensorClientPsm >> Outer >> Inner >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 89: // UP: ( SensorClientPsm >> Outer >> Inner >> InitialState ) => ( SensorClientPsm >> Outer >> Inner >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> Idle )
  public class Lea_0084_0086 : TsmLeaf
  {
    int [] aNatives = { -90, -92 };

    public Lea_0084_0086( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 90, "( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseAbove )" );
      mTransitions[ 1 ] = new TsmTransition( 92, "( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseBelow )" );
    }

    public void Tra_0084_0089( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0084_0091( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0084_0093( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 90:
          return TsmProspect.OK;
        case 92:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 90: // Native: ( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseAbove )
          TsmRecorder.AddNative( "( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseAbove ) # SignalAbove( Target );" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 90;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        case 92: // Native: ( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseBelow )
          TsmRecorder.AddNative( "( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseBelow ) # SignalBelow( Target );" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 92;
          oHandler.bTaken = true;
          mTransitions[ 1 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 89:
        Tra_0084_0089( oHandler );
        break;
      case 90: // UP: ( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseAbove )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 92: // UP: ( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseBelow )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 91:
        Tra_0084_0091( oHandler );
        break;
      case 93:
        Tra_0084_0093( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> SenseAbove )
  public class Lea_0084_0087 : TsmLeaf
  {
    public Lea_0084_0087( TsmBase oParent )
    {
      TsmName = "SenseAbove";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 91, "( SensorClientPsm >> Outer >> Inner >> SenseAbove ) => ( SensorClientPsm >> Outer >> Inner >> Idle ) : CbAbove" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0084_0090( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbAbove( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 91; // CbAbove
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 76:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 76: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 10: // Port___CbAbove
          {
            Port___CbAbove( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90:
        Tra_0084_0090( oHandler );
        break;
      case 91: // UP: ( SensorClientPsm >> Outer >> Inner >> SenseAbove ) => ( SensorClientPsm >> Outer >> Inner >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> SenseBelow )
  public class Lea_0084_0088 : TsmLeaf
  {
    public Lea_0084_0088( TsmBase oParent )
    {
      TsmName = "SenseBelow";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 93, "( SensorClientPsm >> Outer >> Inner >> SenseBelow ) => ( SensorClientPsm >> Outer >> Inner >> Idle ) : CbBelow" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0084_0092( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbBelow( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 93; // CbBelow
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 76:
        switch ( Command )
        {
        case 11:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 76: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 11: // Port___CbBelow
          {
            Port___CbBelow( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 92:
        Tra_0084_0092( oHandler );
        break;
      case 93: // UP: ( SensorClientPsm >> Outer >> Inner >> SenseBelow ) => ( SensorClientPsm >> Outer >> Inner >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >)
  public class Reg_0083_0084 : TsmRegion
  {
    private Ini_0084_0085 oIni_0084_0085; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> InitialState )
    private Lea_0084_0086 oLea_0084_0086; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> Idle )
    private Lea_0084_0087 oLea_0084_0087; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> SenseAbove )
    private Lea_0084_0088 oLea_0084_0088; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >> SenseBelow )

    public Reg_0083_0084( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0084_0085 = new Ini_0084_0085( this );
      oLea_0084_0086 = new Lea_0084_0086( this );
      oLea_0084_0087 = new Lea_0084_0087( this );
      oLea_0084_0088 = new Lea_0084_0088( this );
      mNrStates = 4;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0084_0085;
      mStates[ 1 ] = oLea_0084_0086;
      mStates[ 2 ] = oLea_0084_0087;
      mStates[ 3 ] = oLea_0084_0088;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0084_0085.ExecuteHandler( oHandler );
    }

     // At: ( SensorClientPsm >> Outer >> Inner >> InitialState ) => ( SensorClientPsm >> Outer >> Inner >> Idle )
    public void Tra_0084_0089( TsmHandler oHandler )
    {
      mCurrentState = oLea_0084_0086; // At: ( SensorClientPsm >> Outer >> Inner >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseAbove )
    public void Tra_0084_0090( TsmHandler oHandler )
    {
      ((Cla_0074_0075)oHandler.Owner).Function_1051( oHandler );
      mCurrentState = oLea_0084_0087; // At: ( SensorClientPsm >> Outer >> Inner >> SenseAbove )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseBelow )
    public void Tra_0084_0092( TsmHandler oHandler )
    {
      ((Cla_0074_0075)oHandler.Owner).Function_1052( oHandler );
      mCurrentState = oLea_0084_0088; // At: ( SensorClientPsm >> Outer >> Inner >> SenseBelow )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorClientPsm >> Outer >> Inner >> SenseAbove ) => ( SensorClientPsm >> Outer >> Inner >> Idle )
    public void Tra_0084_0091( TsmHandler oHandler )
    {
      mCurrentState = oLea_0084_0086; // At: ( SensorClientPsm >> Outer >> Inner >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorClientPsm >> Outer >> Inner >> SenseBelow ) => ( SensorClientPsm >> Outer >> Inner >> Idle )
    public void Tra_0084_0093( TsmHandler oHandler )
    {
      mCurrentState = oLea_0084_0086; // At: ( SensorClientPsm >> Outer >> Inner >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 90:
          return TsmProspect.OK;
        case 92:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 76:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 11:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 89:
        Tra_0084_0089( oHandler );
        break;
      case 90:
        Tra_0084_0090( oHandler );
        break;
      case 92:
        Tra_0084_0092( oHandler );
        break;
      case 91:
        Tra_0084_0091( oHandler );
        break;
      case 93:
        Tra_0084_0093( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner )
  public class Com_0081_0083 : TsmCompound
  {
    int [] aNatives = { -96 };
    private Reg_0083_0084 oReg_0083_0084; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner >)

    public Com_0081_0083( TsmBase oParent )
    {
      TsmName = "Inner";
      TsmParent = oParent;
      oReg_0083_0084 = new Reg_0083_0084( this );
      mRegions.Add( oReg_0083_0084 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 96, "( SensorClientPsm >> Outer >> Inner ) => ( SensorClientPsm >> Outer >> Stopping )" );
    }

    public void Tra_0081_0095( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0081_0097( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtMyExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 96:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 96: // Native: ( SensorClientPsm >> Outer >> Inner ) => ( SensorClientPsm >> Outer >> Stopping )
          TsmRecorder.AddNative( "( SensorClientPsm >> Outer >> Inner ) => ( SensorClientPsm >> Outer >> Stopping ) # Stop();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 96;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 95:
        Tra_0081_0095( oHandler );
        break;
      case 96: // UP: ( SensorClientPsm >> Outer >> Inner ) => ( SensorClientPsm >> Outer >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 97:
        Tra_0081_0097( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Stopping )
  public class Lea_0081_0094 : TsmLeaf
  {
    public Lea_0081_0094( TsmBase oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 99, "( SensorClientPsm >> Outer >> Stopping ) => ( SensorClientPsm >> Outer >> Stopping ) : CbAbove" );
      mTransitions[ 1 ] = new TsmTransition( 100, "( SensorClientPsm >> Outer >> Stopping ) => ( SensorClientPsm >> Outer >> Stopping ) : CbBelow" );
      mTransitions[ 2 ] = new TsmTransition( 97, "( SensorClientPsm >> Outer >> Stopping ) => ( SensorClientPsm >> Outer >> Inner ) : CbStopped" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0081_0096( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0081_0099( TsmHandler oHandler )
    {
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Port___CbAbove( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 99; // CbAbove
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0081_0100( TsmHandler oHandler )
    {
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Port___CbBelow( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 100; // CbBelow
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public void Port___CbStopped( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 97; // CbStopped
      oHandler.bTaken = true;
      mTransitions[ 2 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 76:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 11:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 76: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 10: // Port___CbAbove
          {
            Port___CbAbove( oHandler );
          }
          break;
        case 11: // Port___CbBelow
          {
            Port___CbBelow( oHandler );
          }
          break;
        case 12: // Port___CbStopped
          {
            Port___CbStopped( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 96:
        Tra_0081_0096( oHandler );
        break;
      case 99:
        Tra_0081_0099( oHandler );
        break;
      case 100:
        Tra_0081_0100( oHandler );
        break;
      case 97: // UP: ( SensorClientPsm >> Outer >> Stopping ) => ( SensorClientPsm >> Outer >> Inner )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >)
  public class Reg_0080_0081 : TsmRegion
  {
    private Ini_0081_0082 oIni_0081_0082; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> InitialState )
    private Com_0081_0083 oCom_0081_0083; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Inner )
    private Lea_0081_0094 oLea_0081_0094; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >> Stopping )

    public Reg_0080_0081( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0081_0082 = new Ini_0081_0082( this );
      oCom_0081_0083 = new Com_0081_0083( this );
      oLea_0081_0094 = new Lea_0081_0094( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0081_0082;
      mStates[ 1 ] = oCom_0081_0083;
      mStates[ 2 ] = oLea_0081_0094;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0081_0082.ExecuteHandler( oHandler );
    }

     // At: ( SensorClientPsm >> Outer >> InitialState ) => ( SensorClientPsm >> Outer >> Inner )
    public void Tra_0081_0095( TsmHandler oHandler )
    {
      mCurrentState = oCom_0081_0083; // At: ( SensorClientPsm >> Outer >> Inner )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorClientPsm >> Outer >> Inner ) => ( SensorClientPsm >> Outer >> Stopping )
    public void Tra_0081_0096( TsmHandler oHandler )
    {
      ((Cla_0074_0075)oHandler.Owner).Function_1050( oHandler );
      mCurrentState = oLea_0081_0094; // At: ( SensorClientPsm >> Outer >> Stopping )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorClientPsm >> Outer >> Stopping ) => ( SensorClientPsm >> Outer >> Inner )
    public void Tra_0081_0097( TsmHandler oHandler )
    {
      mCurrentState = oCom_0081_0083; // At: ( SensorClientPsm >> Outer >> Inner )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 96:
          return TsmProspect.OK;
        case 90:
          return TsmProspect.OK;
        case 92:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 76:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 11:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 95:
        Tra_0081_0095( oHandler );
        break;
      case 96:
        Tra_0081_0096( oHandler );
        break;
      case 97:
        Tra_0081_0097( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer )
  public class Com_0078_0080 : TsmCompound
  {
    int [] aNatives = { -98 };
    private Reg_0080_0081 oReg_0080_0081; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer >)

    public Com_0078_0080( TsmBase oParent )
    {
      TsmName = "Outer";
      TsmParent = oParent;
      oReg_0080_0081 = new Reg_0080_0081( this );
      mRegions.Add( oReg_0080_0081 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 98, "( SensorClientPsm >> Outer ) => ( SensorClientPsm >> Outer )" );
    }

    public void Tra_0078_0101( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0081_0098( TsmHandler oHandler )
    {
      ((Cla_0074_0075)oHandler.Owner).Function_1049( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.OK;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtMyExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 98:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 98: // Native: ( SensorClientPsm >> Outer ) => ( SensorClientPsm >> Outer )
          TsmRecorder.AddNative( "( SensorClientPsm >> Outer ) => ( SensorClientPsm >> Outer ) # GetTemperature();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 98;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 101:
        Tra_0078_0101( oHandler );
        break;
      case 98:
        Tra_0081_0098( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >)
  public class Reg_0077_0078 : TsmRegion
  {
    private Ini_0078_0079 oIni_0078_0079; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> InitialState )
    private Com_0078_0080 oCom_0078_0080; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >> Outer )

    public Reg_0077_0078( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0078_0079 = new Ini_0078_0079( this );
      oCom_0078_0080 = new Com_0078_0080( this );
      mNrStates = 2;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0078_0079;
      mStates[ 1 ] = oCom_0078_0080;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0078_0079.ExecuteHandler( oHandler );
    }

     // At: ( SensorClientPsm >> InitialState ) => ( SensorClientPsm >> Outer )
    public void Tra_0078_0101( TsmHandler oHandler )
    {
      mCurrentState = oCom_0078_0080; // At: ( SensorClientPsm >> Outer )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 98:
          return TsmProspect.OK;
        case 96:
          return TsmProspect.OK;
        case 90:
          return TsmProspect.OK;
        case 92:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 76:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 11:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 101:
        Tra_0078_0101( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm )
  public class Fsm_0075_0077 : TsmFsm
  {
    private Reg_0077_0078 oReg_0077_0078; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm >)

    public Fsm_0075_0077( TsmBase oParent )
    {
      TsmName = "SensorClientPsm";
      TsmParent = oParent;
      oReg_0077_0078 = new Reg_0077_0078( this );
      mRegions.Add( oReg_0077_0078 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorClient )
  public class Cla_0074_0075 : TsmProtocolClass
  {
    private Fsm_0075_0077 oFsm_0075_0077; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > SensorClientPsm )
    private TsmIPort_ISensor Port; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > Port )
    private TsmIPort_ICbSensor TsmPI__Port; // ( Xmi > Data > Protocols > SensorProtocol > SensorClient > Port )
    private TsmPCPort mPCMessager;
    private int Target = 21;

    public Cla_0074_0075( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0075_0077 = new Fsm_0075_0077( this );
      TsmPI__Port = new TsmIPort_ICbSensor( this );
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0075_0077;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SensorProtocol > SensorClient )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ISensor) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SensorProtocol > SensorClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0075_0077.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( SensorClientPsm >> Outer ) => ( SensorClientPsm >> Outer )
    public void Function_1049( TsmHandler oHandler )
    {
      Port.GetTemperature();
    }

     // ( SensorClientPsm >> Outer >> Inner ) => ( SensorClientPsm >> Outer >> Stopping )
    public void Function_1050( TsmHandler oHandler )
    {
      Port.Stop();
    }

     // ( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseAbove )
    public void Function_1051( TsmHandler oHandler )
    {
      Port.SignalAbove( Target );
    }

     // ( SensorClientPsm >> Outer >> Inner >> Idle ) => ( SensorClientPsm >> Outer >> Inner >> SenseBelow )
    public void Function_1052( TsmHandler oHandler )
    {
      Port.SignalBelow( Target );
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 76;
      TsmPI__Port.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0075_0077.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> InitialState )
  public class Ini_0105_0106 : TsmPseudo
  {
    public Ini_0105_0106( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 133, "( SensorServerPsm >> InitialState ) => ( SensorServerPsm >> Outer )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 133; // TRLS ( SensorServerPsm >> InitialState ) => ( SensorServerPsm >> Outer )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 133: // UP: ( SensorServerPsm >> InitialState ) => ( SensorServerPsm >> Outer )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> InitialState )
  public class Ini_0108_0109 : TsmPseudo
  {
    public Ini_0108_0109( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 122, "( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Inner )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 122; // TRLS ( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Inner )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 122: // UP: ( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Inner )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> InitialState )
  public class Ini_0111_0112 : TsmPseudo
  {
    public Ini_0111_0112( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 116, "( SensorServerPsm >> Outer >> Inner >> InitialState ) => ( SensorServerPsm >> Outer >> Inner >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 116; // TRLS ( SensorServerPsm >> Outer >> Inner >> InitialState ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 116: // UP: ( SensorServerPsm >> Outer >> Inner >> InitialState ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> Idle )
  public class Lea_0111_0113 : TsmLeaf
  {
    public Lea_0111_0113( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 117, "( SensorServerPsm >> Outer >> Inner >> Idle ) => ( SensorServerPsm >> Outer >> Inner >> SenseAbove ) : SignalAbove" );
      mTransitions[ 1 ] = new TsmTransition( 119, "( SensorServerPsm >> Outer >> Inner >> Idle ) => ( SensorServerPsm >> Outer >> Inner >> SenseBelow ) : SignalBelow" );
    }

    public void Tra_0111_0116( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0111_0118( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0111_0120( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___SignalAbove( int Target, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 117; // SignalAbove
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Port___SignalBelow( int Target, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 119; // SignalBelow
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 103:
        switch ( Command )
        {
        case 14:
          return TsmProspect.OK;
        case 15:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 103: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 14: // Port___SignalAbove
          {
            TsmTrigger_ISensor___SignalAbove lTrigger = (TsmTrigger_ISensor___SignalAbove) oHandler.Trigger;

            Port___SignalAbove( lTrigger.Target, oHandler );
          }
          break;
        case 15: // Port___SignalBelow
          {
            TsmTrigger_ISensor___SignalBelow lTrigger = (TsmTrigger_ISensor___SignalBelow) oHandler.Trigger;

            Port___SignalBelow( lTrigger.Target, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 116:
        Tra_0111_0116( oHandler );
        break;
      case 118:
        Tra_0111_0118( oHandler );
        break;
      case 120:
        Tra_0111_0120( oHandler );
        break;
      case 117: // UP: ( SensorServerPsm >> Outer >> Inner >> Idle ) => ( SensorServerPsm >> Outer >> Inner >> SenseAbove )
        bHigher = true;
        break;
      case 119: // UP: ( SensorServerPsm >> Outer >> Inner >> Idle ) => ( SensorServerPsm >> Outer >> Inner >> SenseBelow )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> SenseAbove )
  public class Lea_0111_0114 : TsmLeaf
  {
    int [] aNatives = { 118 };

    public Lea_0111_0114( TsmBase oParent )
    {
      TsmName = "SenseAbove";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 118, "( SensorServerPsm >> Outer >> Inner >> SenseAbove ) => ( SensorServerPsm >> Outer >> Inner >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0111_0117( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 118:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 118: // Native: ( SensorServerPsm >> Outer >> Inner >> SenseAbove ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
          TsmRecorder.AddNative( "( SensorServerPsm >> Outer >> Inner >> SenseAbove ) => ( SensorServerPsm >> Outer >> Inner >> Idle ) # CbAbove();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 118;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 118: // UP: ( SensorServerPsm >> Outer >> Inner >> SenseAbove ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 117:
        Tra_0111_0117( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> SenseBelow )
  public class Lea_0111_0115 : TsmLeaf
  {
    int [] aNatives = { 120 };

    public Lea_0111_0115( TsmBase oParent )
    {
      TsmName = "SenseBelow";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 120, "( SensorServerPsm >> Outer >> Inner >> SenseBelow ) => ( SensorServerPsm >> Outer >> Inner >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0111_0119( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 120:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 120: // Native: ( SensorServerPsm >> Outer >> Inner >> SenseBelow ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
          TsmRecorder.AddNative( "( SensorServerPsm >> Outer >> Inner >> SenseBelow ) => ( SensorServerPsm >> Outer >> Inner >> Idle ) # CbBelow();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 120;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 120: // UP: ( SensorServerPsm >> Outer >> Inner >> SenseBelow ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 119:
        Tra_0111_0119( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >)
  public class Reg_0110_0111 : TsmRegion
  {
    private Ini_0111_0112 oIni_0111_0112; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> InitialState )
    private Lea_0111_0113 oLea_0111_0113; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> Idle )
    private Lea_0111_0114 oLea_0111_0114; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> SenseAbove )
    private Lea_0111_0115 oLea_0111_0115; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >> SenseBelow )

    public Reg_0110_0111( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0111_0112 = new Ini_0111_0112( this );
      oLea_0111_0113 = new Lea_0111_0113( this );
      oLea_0111_0114 = new Lea_0111_0114( this );
      oLea_0111_0115 = new Lea_0111_0115( this );
      mNrStates = 4;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0111_0112;
      mStates[ 1 ] = oLea_0111_0113;
      mStates[ 2 ] = oLea_0111_0114;
      mStates[ 3 ] = oLea_0111_0115;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0111_0112.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> Inner >> InitialState ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
    public void Tra_0111_0116( TsmHandler oHandler )
    {
      mCurrentState = oLea_0111_0113; // At: ( SensorServerPsm >> Outer >> Inner >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> Inner >> SenseAbove ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
    public void Tra_0111_0118( TsmHandler oHandler )
    {
      ((Cla_0074_0102)oHandler.Owner).Function_1053( oHandler );
      mCurrentState = oLea_0111_0113; // At: ( SensorServerPsm >> Outer >> Inner >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> Inner >> SenseBelow ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
    public void Tra_0111_0120( TsmHandler oHandler )
    {
      ((Cla_0074_0102)oHandler.Owner).Function_1054( oHandler );
      mCurrentState = oLea_0111_0113; // At: ( SensorServerPsm >> Outer >> Inner >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> Inner >> Idle ) => ( SensorServerPsm >> Outer >> Inner >> SenseAbove )
    public void Tra_0111_0117( TsmHandler oHandler )
    {
      mCurrentState = oLea_0111_0114; // At: ( SensorServerPsm >> Outer >> Inner >> SenseAbove )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> Inner >> Idle ) => ( SensorServerPsm >> Outer >> Inner >> SenseBelow )
    public void Tra_0111_0119( TsmHandler oHandler )
    {
      mCurrentState = oLea_0111_0115; // At: ( SensorServerPsm >> Outer >> Inner >> SenseBelow )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 118:
          return TsmProspect.OK;
        case 120:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 103:
        switch ( Command )
        {
        case 14:
          return TsmProspect.OK;
        case 15:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 116:
        Tra_0111_0116( oHandler );
        break;
      case 118:
        Tra_0111_0118( oHandler );
        break;
      case 120:
        Tra_0111_0120( oHandler );
        break;
      case 117:
        Tra_0111_0117( oHandler );
        break;
      case 119:
        Tra_0111_0119( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner )
  public class Com_0108_0110 : TsmCompound
  {
    private Reg_0110_0111 oReg_0110_0111; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner >)

    public Com_0108_0110( TsmBase oParent )
    {
      TsmName = "Inner";
      TsmParent = oParent;
      oReg_0110_0111 = new Reg_0110_0111( this );
      mRegions.Add( oReg_0110_0111 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 123, "( SensorServerPsm >> Outer >> Inner ) => ( SensorServerPsm >> Outer >> Stopping ) : Stop" );
    }

    public void Tra_0108_0122( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0108_0124( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___Stop( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 123; // Stop
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 103:
        switch ( Command )
        {
        case 16:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 103: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 16: // Port___Stop
          {
            Port___Stop( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 122:
        Tra_0108_0122( oHandler );
        break;
      case 124:
        Tra_0108_0124( oHandler );
        break;
      case 123: // UP: ( SensorServerPsm >> Outer >> Inner ) => ( SensorServerPsm >> Outer >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Stopping )
  public class Lea_0108_0121 : TsmLeaf
  {
    int [] aNatives = { 124 };

    public Lea_0108_0121( TsmBase oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 124, "( SensorServerPsm >> Outer >> Stopping ) => ( SensorServerPsm >> Outer >> Inner )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0108_0123( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 124:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 124: // Native: ( SensorServerPsm >> Outer >> Stopping ) => ( SensorServerPsm >> Outer >> Inner )
          TsmRecorder.AddNative( "( SensorServerPsm >> Outer >> Stopping ) => ( SensorServerPsm >> Outer >> Inner ) # CbStopped();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 124;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 124: // UP: ( SensorServerPsm >> Outer >> Stopping ) => ( SensorServerPsm >> Outer >> Inner )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 123:
        Tra_0108_0123( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >)
  public class Reg_0107_0108 : TsmRegion
  {
    private Ini_0108_0109 oIni_0108_0109; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> InitialState )
    private Com_0108_0110 oCom_0108_0110; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Inner )
    private Lea_0108_0121 oLea_0108_0121; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Stopping )

    public Reg_0107_0108( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0108_0109 = new Ini_0108_0109( this );
      oCom_0108_0110 = new Com_0108_0110( this );
      oLea_0108_0121 = new Lea_0108_0121( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0108_0109;
      mStates[ 1 ] = oCom_0108_0110;
      mStates[ 2 ] = oLea_0108_0121;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0108_0109.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Inner )
    public void Tra_0108_0122( TsmHandler oHandler )
    {
      mCurrentState = oCom_0108_0110; // At: ( SensorServerPsm >> Outer >> Inner )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> Stopping ) => ( SensorServerPsm >> Outer >> Inner )
    public void Tra_0108_0124( TsmHandler oHandler )
    {
      ((Cla_0074_0102)oHandler.Owner).Function_1055( oHandler );
      mCurrentState = oCom_0108_0110; // At: ( SensorServerPsm >> Outer >> Inner )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> Inner ) => ( SensorServerPsm >> Outer >> Stopping )
    public void Tra_0108_0123( TsmHandler oHandler )
    {
      mCurrentState = oLea_0108_0121; // At: ( SensorServerPsm >> Outer >> Stopping )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 118:
          return TsmProspect.OK;
        case 120:
          return TsmProspect.OK;
        case 124:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 103:
        switch ( Command )
        {
        case 14:
          return TsmProspect.OK;
        case 15:
          return TsmProspect.OK;
        case 16:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 122:
        Tra_0108_0122( oHandler );
        break;
      case 124:
        Tra_0108_0124( oHandler );
        break;
      case 123:
        Tra_0108_0123( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> InitialState )
  public class Ini_0125_0126 : TsmPseudo
  {
    public Ini_0125_0126( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 129, "( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Get )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 129; // TRLS ( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Get )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 129: // UP: ( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Get )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> ChoiceState )
  public class Cho_0125_0127 : TsmPseudo
  {
    private int MaxNrChoices = 2;

    public Cho_0125_0127( TsmBase oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 131, "( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )" );
      mTransitions[ 1 ] = new TsmTransition( 132, "( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "cold" ) )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 131; // TRLS ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
        mTransitions[ 0 ].bVisit = true;
      }
      else
      if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 132; // TRLS ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
        mTransitions[ 1 ].bVisit = true;
      }
    }

    public void Tra_0125_0130( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 131: // UP: ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
        bHigher = true;
        break;
      case 132: // UP: ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
        bHigher = true;
        break;
      case 130:
        Tra_0125_0130( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Get )
  public class Lea_0125_0128 : TsmLeaf
  {
    public Lea_0125_0128( TsmBase oParent )
    {
      TsmName = "Get";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 130, "( SensorServerPsm >> Outer >> Get ) => ( SensorServerPsm >> Outer >> ChoiceState ) : GetTemperature" );
    }

    public void Tra_0125_0129( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0125_0131( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0125_0132( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Port___GetTemperature( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 130; // GetTemperature
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 103:
        switch ( Command )
        {
        case 13:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 103: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 13: // Port___GetTemperature
          {
            Port___GetTemperature( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 129:
        Tra_0125_0129( oHandler );
        break;
      case 131:
        Tra_0125_0131( oHandler );
        break;
      case 132:
        Tra_0125_0132( oHandler );
        break;
      case 130: // UP: ( SensorServerPsm >> Outer >> Get ) => ( SensorServerPsm >> Outer >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >)
  public class Reg_0107_0125 : TsmRegion
  {
    private Ini_0125_0126 oIni_0125_0126; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> InitialState )
    private Cho_0125_0127 oCho_0125_0127; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> ChoiceState )
    private Lea_0125_0128 oLea_0125_0128; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >> Get )

    public Reg_0107_0125( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0125_0126 = new Ini_0125_0126( this );
      oCho_0125_0127 = new Cho_0125_0127( this );
      oLea_0125_0128 = new Lea_0125_0128( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0125_0126;
      mStates[ 1 ] = oCho_0125_0127;
      mStates[ 2 ] = oLea_0125_0128;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0125_0126.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> InitialState ) => ( SensorServerPsm >> Outer >> Get )
    public void Tra_0125_0129( TsmHandler oHandler )
    {
      mCurrentState = oLea_0125_0128; // At: ( SensorServerPsm >> Outer >> Get )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
    public void Tra_0125_0131( TsmHandler oHandler )
    {
      ((Cla_0074_0102)oHandler.Owner).Function_1007( oHandler );
      mCurrentState = oLea_0125_0128; // At: ( SensorServerPsm >> Outer >> Get )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
    public void Tra_0125_0132( TsmHandler oHandler )
    {
      ((Cla_0074_0102)oHandler.Owner).Function_1009( oHandler );
      mCurrentState = oLea_0125_0128; // At: ( SensorServerPsm >> Outer >> Get )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> Outer >> Get ) => ( SensorServerPsm >> Outer >> ChoiceState )
    public void Tra_0125_0130( TsmHandler oHandler )
    {
      mCurrentState = oCho_0125_0127; // At: ( SensorServerPsm >> Outer >> ChoiceState )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 103:
        switch ( Command )
        {
        case 13:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 129:
        Tra_0125_0129( oHandler );
        break;
      case 131:
        Tra_0125_0131( oHandler );
        break;
      case 132:
        Tra_0125_0132( oHandler );
        break;
      case 130:
        Tra_0125_0130( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer )
  public class Com_0105_0107 : TsmCompound
  {
    private Reg_0107_0108 oReg_0107_0108; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >)
    private Reg_0107_0125 oReg_0107_0125; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer >)

    public Com_0105_0107( TsmBase oParent )
    {
      TsmName = "Outer";
      TsmParent = oParent;
      oReg_0107_0108 = new Reg_0107_0108( this );
      oReg_0107_0125 = new Reg_0107_0125( this );
      mRegions.Add( oReg_0107_0108 );
      mRegions.Add( oReg_0107_0125 );
      mNrTransitions = 0;
    }

    public void Tra_0105_0133( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 133:
        Tra_0105_0133( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >)
  public class Reg_0104_0105 : TsmRegion
  {
    private Ini_0105_0106 oIni_0105_0106; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> InitialState )
    private Com_0105_0107 oCom_0105_0107; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >> Outer )

    public Reg_0104_0105( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0105_0106 = new Ini_0105_0106( this );
      oCom_0105_0107 = new Com_0105_0107( this );
      mNrStates = 2;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0105_0106;
      mStates[ 1 ] = oCom_0105_0107;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0105_0106.ExecuteHandler( oHandler );
    }

     // At: ( SensorServerPsm >> InitialState ) => ( SensorServerPsm >> Outer )
    public void Tra_0105_0133( TsmHandler oHandler )
    {
      mCurrentState = oCom_0105_0107; // At: ( SensorServerPsm >> Outer )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 118:
          return TsmProspect.OK;
        case 120:
          return TsmProspect.OK;
        case 124:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 103:
        switch ( Command )
        {
        case 13:
          return TsmProspect.OK;
        case 14:
          return TsmProspect.OK;
        case 15:
          return TsmProspect.OK;
        case 16:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 133:
        Tra_0105_0133( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm )
  public class Fsm_0102_0104 : TsmFsm
  {
    private Reg_0104_0105 oReg_0104_0105; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm >)

    public Fsm_0102_0104( TsmBase oParent )
    {
      TsmName = "SensorServerPsm";
      TsmParent = oParent;
      oReg_0104_0105 = new Reg_0104_0105( this );
      mRegions.Add( oReg_0104_0105 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > SensorProtocol > SensorServer )
  public class Cla_0074_0102 : TsmProtocolClass
  {
    private Fsm_0102_0104 oFsm_0102_0104; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > SensorServerPsm )
    private TsmIPort_ISensor TsmPI__Port; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > Port )
    private TsmIPort_ICbSensor Port; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > Port )
    private TsmPSPort mPSMessager;

    public Cla_0074_0102( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0102_0104 = new Fsm_0102_0104( this );
      TsmPI__Port = new TsmIPort_ISensor( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0102_0104;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SensorProtocol > SensorServer )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ICbSensor) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SensorProtocol > SensorServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0102_0104.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
    public double Function_1006()
    {
      return 16.0;
    }

     // ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
    public void Function_1007( TsmHandler oHandler )
    {
      TsmTrigger_ISensor___GetTemperature lTrigger = (TsmTrigger_ISensor___GetTemperature) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0074_0102)oHandler.Owner).Function_1006();
    }

     // ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
    public double Function_1008()
    {
      return 24.0;
    }

     // ( SensorServerPsm >> Outer >> ChoiceState ) => ( SensorServerPsm >> Outer >> Get )
    public void Function_1009( TsmHandler oHandler )
    {
      TsmTrigger_ISensor___GetTemperature lTrigger = (TsmTrigger_ISensor___GetTemperature) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0074_0102)oHandler.Owner).Function_1008();
    }

     // ( SensorServerPsm >> Outer >> Inner >> SenseAbove ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
    public void Function_1053( TsmHandler oHandler )
    {
      Port.CbAbove();
    }

     // ( SensorServerPsm >> Outer >> Inner >> SenseBelow ) => ( SensorServerPsm >> Outer >> Inner >> Idle )
    public void Function_1054( TsmHandler oHandler )
    {
      Port.CbBelow();
    }

     // ( SensorServerPsm >> Outer >> Stopping ) => ( SensorServerPsm >> Outer >> Inner )
    public void Function_1055( TsmHandler oHandler )
    {
      Port.CbStopped();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 103;
      TsmPI__Port.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0102_0104.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > SensorProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > SensorProtocol )
  public class Pac_0002_0074 : TsmPackage
  {
    public Pac_0002_0074( TsmBase oParent )
    {
      TsmName = "SensorProtocol";
      TsmParent = oParent;
    }
  }

  public interface ICooler
  {
    void Start();
    void Stop();
  }

  public class TsmTrigger_ICooler___Start : TsmTrigger
  {
    public TsmTrigger_ICooler___Start()
      : base( 17 )
    {
    }
  }

  public class TsmTrigger_ICooler___Stop : TsmTrigger
  {
    public TsmTrigger_ICooler___Stop()
      : base( 18 )
    {
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > ICooler )
  public class TsmIPort_ICooler : TsmInterfacePort, ICooler
  {
    public TsmIPort_ICooler( TsmBase oParent )
    {
      TsmName = "ICooler";
      TsmParent = oParent;
    }

    public virtual void Start()
    {
      TsmTrigger_ICooler___Start tt = new TsmTrigger_ICooler___Start();
      TsmRecorder.AddCall( "Start", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void Stop()
    {
      TsmTrigger_ICooler___Stop tt = new TsmTrigger_ICooler___Stop();
      TsmRecorder.AddCall( "Stop", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> InitialState )
  public class Ini_0138_0139 : TsmPseudo
  {
    public Ini_0138_0139( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 144, "( CoolerServerPsm >> InitialState ) => ( CoolerServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 144; // TRLS ( CoolerServerPsm >> InitialState ) => ( CoolerServerPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 144: // UP: ( CoolerServerPsm >> InitialState ) => ( CoolerServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> Idle )
  public class Lea_0138_0140 : TsmLeaf
  {
    public Lea_0138_0140( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 142, "( CoolerServerPsm >> Idle ) => ( CoolerServerPsm >> Busy ) : Start" );
    }

    public void Tra_0138_0144( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Port___Start( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 142; // Start
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0138_0143( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 136:
        switch ( Command )
        {
        case 17:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 136: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 17: // Port___Start
          {
            Port___Start( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 144:
        Tra_0138_0144( oHandler );
        break;
      case 142: // UP: ( CoolerServerPsm >> Idle ) => ( CoolerServerPsm >> Busy )
        bHigher = true;
        break;
      case 143:
        Tra_0138_0143( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> Busy )
  public class Lea_0138_0141 : TsmLeaf
  {
    public Lea_0138_0141( TsmBase oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 143, "( CoolerServerPsm >> Busy ) => ( CoolerServerPsm >> Idle ) : Stop" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0138_0142( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___Stop( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 143; // Stop
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 136:
        switch ( Command )
        {
        case 18:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 136: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 18: // Port___Stop
          {
            Port___Stop( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 142:
        Tra_0138_0142( oHandler );
        break;
      case 143: // UP: ( CoolerServerPsm >> Busy ) => ( CoolerServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >)
  public class Reg_0137_0138 : TsmRegion
  {
    private Ini_0138_0139 oIni_0138_0139; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> InitialState )
    private Lea_0138_0140 oLea_0138_0140; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> Idle )
    private Lea_0138_0141 oLea_0138_0141; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >> Busy )

    public Reg_0137_0138( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0138_0139 = new Ini_0138_0139( this );
      oLea_0138_0140 = new Lea_0138_0140( this );
      oLea_0138_0141 = new Lea_0138_0141( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0138_0139;
      mStates[ 1 ] = oLea_0138_0140;
      mStates[ 2 ] = oLea_0138_0141;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0138_0139.ExecuteHandler( oHandler );
    }

     // At: ( CoolerServerPsm >> InitialState ) => ( CoolerServerPsm >> Idle )
    public void Tra_0138_0144( TsmHandler oHandler )
    {
      mCurrentState = oLea_0138_0140; // At: ( CoolerServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CoolerServerPsm >> Idle ) => ( CoolerServerPsm >> Busy )
    public void Tra_0138_0142( TsmHandler oHandler )
    {
      mCurrentState = oLea_0138_0141; // At: ( CoolerServerPsm >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CoolerServerPsm >> Busy ) => ( CoolerServerPsm >> Idle )
    public void Tra_0138_0143( TsmHandler oHandler )
    {
      mCurrentState = oLea_0138_0140; // At: ( CoolerServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 136:
        switch ( Command )
        {
        case 17:
          return TsmProspect.OK;
        case 18:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 144:
        Tra_0138_0144( oHandler );
        break;
      case 142:
        Tra_0138_0142( oHandler );
        break;
      case 143:
        Tra_0138_0143( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm )
  public class Fsm_0135_0137 : TsmFsm
  {
    private Reg_0137_0138 oReg_0137_0138; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm >)

    public Fsm_0135_0137( TsmBase oParent )
    {
      TsmName = "CoolerServerPsm";
      TsmParent = oParent;
      oReg_0137_0138 = new Reg_0137_0138( this );
      mRegions.Add( oReg_0137_0138 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer )
  public class Cla_0134_0135 : TsmProtocolClass
  {
    private Fsm_0135_0137 oFsm_0135_0137; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > CoolerServerPsm )
    private TsmIPort_ICooler TsmPI__Port; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > Port )
    private TsmPSPort mPSMessager;

    public Cla_0134_0135( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0135_0137 = new Fsm_0135_0137( this );
      TsmPI__Port = new TsmIPort_ICooler( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0135_0137;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0135_0137.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 136;
      TsmPI__Port.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0135_0137.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> InitialState )
  public class Ini_0148_0149 : TsmPseudo
  {
    public Ini_0148_0149( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 154, "( CoolerClientPsm >> InitialState ) => ( CoolerClientPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 154; // TRLS ( CoolerClientPsm >> InitialState ) => ( CoolerClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 154: // UP: ( CoolerClientPsm >> InitialState ) => ( CoolerClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> Idle )
  public class Lea_0148_0150 : TsmLeaf
  {
    int [] aNatives = { -152 };

    public Lea_0148_0150( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 152, "( CoolerClientPsm >> Idle ) => ( CoolerClientPsm >> Busy )" );
    }

    public void Tra_0148_0154( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0148_0153( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 152:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 152: // Native: ( CoolerClientPsm >> Idle ) => ( CoolerClientPsm >> Busy )
          TsmRecorder.AddNative( "( CoolerClientPsm >> Idle ) => ( CoolerClientPsm >> Busy ) # Start();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 152;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 154:
        Tra_0148_0154( oHandler );
        break;
      case 152: // UP: ( CoolerClientPsm >> Idle ) => ( CoolerClientPsm >> Busy )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 153:
        Tra_0148_0153( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> Busy )
  public class Lea_0148_0151 : TsmLeaf
  {
    int [] aNatives = { -153 };

    public Lea_0148_0151( TsmBase oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 153, "( CoolerClientPsm >> Busy ) => ( CoolerClientPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0148_0152( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 153:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 153: // Native: ( CoolerClientPsm >> Busy ) => ( CoolerClientPsm >> Idle )
          TsmRecorder.AddNative( "( CoolerClientPsm >> Busy ) => ( CoolerClientPsm >> Idle ) # Stop();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 153;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 152:
        Tra_0148_0152( oHandler );
        break;
      case 153: // UP: ( CoolerClientPsm >> Busy ) => ( CoolerClientPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >)
  public class Reg_0147_0148 : TsmRegion
  {
    private Ini_0148_0149 oIni_0148_0149; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> InitialState )
    private Lea_0148_0150 oLea_0148_0150; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> Idle )
    private Lea_0148_0151 oLea_0148_0151; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >> Busy )

    public Reg_0147_0148( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0148_0149 = new Ini_0148_0149( this );
      oLea_0148_0150 = new Lea_0148_0150( this );
      oLea_0148_0151 = new Lea_0148_0151( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0148_0149;
      mStates[ 1 ] = oLea_0148_0150;
      mStates[ 2 ] = oLea_0148_0151;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0148_0149.ExecuteHandler( oHandler );
    }

     // At: ( CoolerClientPsm >> InitialState ) => ( CoolerClientPsm >> Idle )
    public void Tra_0148_0154( TsmHandler oHandler )
    {
      mCurrentState = oLea_0148_0150; // At: ( CoolerClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CoolerClientPsm >> Idle ) => ( CoolerClientPsm >> Busy )
    public void Tra_0148_0152( TsmHandler oHandler )
    {
      ((Cla_0134_0145)oHandler.Owner).Function_1056( oHandler );
      mCurrentState = oLea_0148_0151; // At: ( CoolerClientPsm >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CoolerClientPsm >> Busy ) => ( CoolerClientPsm >> Idle )
    public void Tra_0148_0153( TsmHandler oHandler )
    {
      ((Cla_0134_0145)oHandler.Owner).Function_1057( oHandler );
      mCurrentState = oLea_0148_0150; // At: ( CoolerClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 152:
          return TsmProspect.OK;
        case 153:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 154:
        Tra_0148_0154( oHandler );
        break;
      case 152:
        Tra_0148_0152( oHandler );
        break;
      case 153:
        Tra_0148_0153( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm )
  public class Fsm_0145_0147 : TsmFsm
  {
    private Reg_0147_0148 oReg_0147_0148; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm >)

    public Fsm_0145_0147( TsmBase oParent )
    {
      TsmName = "CoolerClientPsm";
      TsmParent = oParent;
      oReg_0147_0148 = new Reg_0147_0148( this );
      mRegions.Add( oReg_0147_0148 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient )
  public class Cla_0134_0145 : TsmProtocolClass
  {
    private Fsm_0145_0147 oFsm_0145_0147; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > CoolerClientPsm )
    private TsmIPort_ICooler Port; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient > Port )

    public Cla_0134_0145( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0145_0147 = new Fsm_0145_0147( this );
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0145_0147;
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ICooler) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > CoolerProtocol > CoolerClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0145_0147.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( CoolerClientPsm >> Idle ) => ( CoolerClientPsm >> Busy )
    public void Function_1056( TsmHandler oHandler )
    {
      Port.Start();
    }

     // ( CoolerClientPsm >> Busy ) => ( CoolerClientPsm >> Idle )
    public void Function_1057( TsmHandler oHandler )
    {
      Port.Stop();
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0145_0147.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > CoolerProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > CoolerProtocol )
  public class Pac_0002_0134 : TsmPackage
  {
    public Pac_0002_0134( TsmBase oParent )
    {
      TsmName = "CoolerProtocol";
      TsmParent = oParent;
    }
  }

  public interface IFan
  {
    void Stop();
    void ToLow();
    void ToHigh();
  }

  public class TsmTrigger_IFan___Stop : TsmTrigger
  {
    public TsmTrigger_IFan___Stop()
      : base( 19 )
    {
    }
  }

  public class TsmTrigger_IFan___ToLow : TsmTrigger
  {
    public TsmTrigger_IFan___ToLow()
      : base( 20 )
    {
    }
  }

  public class TsmTrigger_IFan___ToHigh : TsmTrigger
  {
    public TsmTrigger_IFan___ToHigh()
      : base( 21 )
    {
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > IFan )
  public class TsmIPort_IFan : TsmInterfacePort, IFan
  {
    public TsmIPort_IFan( TsmBase oParent )
    {
      TsmName = "IFan";
      TsmParent = oParent;
    }

    public virtual void Stop()
    {
      TsmTrigger_IFan___Stop tt = new TsmTrigger_IFan___Stop();
      TsmRecorder.AddCall( "Stop", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void ToLow()
    {
      TsmTrigger_IFan___ToLow tt = new TsmTrigger_IFan___ToLow();
      TsmRecorder.AddCall( "ToLow", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void ToHigh()
    {
      TsmTrigger_IFan___ToHigh tt = new TsmTrigger_IFan___ToHigh();
      TsmRecorder.AddCall( "ToHigh", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> InitialState )
  public class Ini_0159_0160 : TsmPseudo
  {
    public Ini_0159_0160( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 171, "( FanServerPsm >> InitialState ) => ( FanServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 171; // TRLS ( FanServerPsm >> InitialState ) => ( FanServerPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 171: // UP: ( FanServerPsm >> InitialState ) => ( FanServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >> Low )
  public class Lea_0162_0163 : TsmLeaf
  {
    public Lea_0162_0163( TsmBase oParent )
    {
      TsmName = "Low";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 165, "( FanServerPsm >> Busy >> Low ) => ( FanServerPsm >> Busy >> High ) : ToHigh" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0162_0166( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0159_0168( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___ToHigh( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 165; // ToHigh
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 157:
        switch ( Command )
        {
        case 21:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 157: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 21: // Port___ToHigh
          {
            Port___ToHigh( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 166:
        Tra_0162_0166( oHandler );
        break;
      case 168:
        Tra_0159_0168( oHandler );
        break;
      case 165: // UP: ( FanServerPsm >> Busy >> Low ) => ( FanServerPsm >> Busy >> High )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >> High )
  public class Lea_0162_0164 : TsmLeaf
  {
    public Lea_0162_0164( TsmBase oParent )
    {
      TsmName = "High";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 166, "( FanServerPsm >> Busy >> High ) => ( FanServerPsm >> Busy >> Low ) : ToLow" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Port___ToLow( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 166; // ToLow
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0162_0165( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0159_0169( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 157:
        switch ( Command )
        {
        case 20:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 157: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 20: // Port___ToLow
          {
            Port___ToLow( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 166: // UP: ( FanServerPsm >> Busy >> High ) => ( FanServerPsm >> Busy >> Low )
        bHigher = true;
        break;
      case 165:
        Tra_0162_0165( oHandler );
        break;
      case 169:
        Tra_0159_0169( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >)
  public class Reg_0161_0162 : TsmRegion
  {
    private Lea_0162_0163 oLea_0162_0163; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >> Low )
    private Lea_0162_0164 oLea_0162_0164; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >> High )

    public Reg_0161_0162( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oLea_0162_0163 = new Lea_0162_0163( this );
      oLea_0162_0164 = new Lea_0162_0164( this );
      mNrStates = 2;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oLea_0162_0163;
      mStates[ 1 ] = oLea_0162_0164;
    }

     // At: ( FanServerPsm >> Busy >> High ) => ( FanServerPsm >> Busy >> Low )
    public void Tra_0162_0166( TsmHandler oHandler )
    {
      mCurrentState = oLea_0162_0163; // At: ( FanServerPsm >> Busy >> Low )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // Down: ( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> Low )
    public void Tra_0159_0168( TsmHandler oHandler )
    {
      mCurrentState = oLea_0162_0163; // Down: ( FanServerPsm >> Busy >> Low )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( FanServerPsm >> Busy >> Low ) => ( FanServerPsm >> Busy >> High )
    public void Tra_0162_0165( TsmHandler oHandler )
    {
      mCurrentState = oLea_0162_0164; // At: ( FanServerPsm >> Busy >> High )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // Down: ( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> High )
    public void Tra_0159_0169( TsmHandler oHandler )
    {
      mCurrentState = oLea_0162_0164; // Down: ( FanServerPsm >> Busy >> High )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 157:
        switch ( Command )
        {
        case 20:
          return TsmProspect.OK;
        case 21:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 166:
        Tra_0162_0166( oHandler );
        break;
      case 168:
        Tra_0159_0168( oHandler );
        break;
      case 165:
        Tra_0162_0165( oHandler );
        break;
      case 169:
        Tra_0159_0169( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy )
  public class Com_0159_0161 : TsmCompound
  {
    private Reg_0161_0162 oReg_0161_0162; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy >)

    public Com_0159_0161( TsmBase oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      oReg_0161_0162 = new Reg_0161_0162( this );
      mRegions.Add( oReg_0161_0162 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 170, "( FanServerPsm >> Busy ) => ( FanServerPsm >> Idle ) : Stop" );
    }

    public void Port___Stop( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 170; // Stop
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0159_0168( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oReg_0161_0162.ExecuteHandler( oHandler );
    }

    public void Tra_0159_0169( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oReg_0161_0162.ExecuteHandler( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 157:
        switch ( Command )
        {
        case 19:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 157: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 19: // Port___Stop
          {
            Port___Stop( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 170: // UP: ( FanServerPsm >> Busy ) => ( FanServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 168:
        Tra_0159_0168( oHandler );
        break;
      case 169:
        Tra_0159_0169( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Idle )
  public class Lea_0159_0167 : TsmLeaf
  {
    public Lea_0159_0167( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 168, "( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> Low ) : ToLow" );
      mTransitions[ 1 ] = new TsmTransition( 169, "( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> High ) : ToHigh" );
    }

    public void Tra_0159_0171( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0159_0170( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___ToLow( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 168; // ToLow
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Port___ToHigh( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 169; // ToHigh
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 157:
        switch ( Command )
        {
        case 20:
          return TsmProspect.OK;
        case 21:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 157: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 20: // Port___ToLow
          {
            Port___ToLow( oHandler );
          }
          break;
        case 21: // Port___ToHigh
          {
            Port___ToHigh( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 171:
        Tra_0159_0171( oHandler );
        break;
      case 170:
        Tra_0159_0170( oHandler );
        break;
      case 168: // UP: ( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> Low )
        bHigher = true;
        break;
      case 169: // UP: ( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> High )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >)
  public class Reg_0158_0159 : TsmRegion
  {
    private Ini_0159_0160 oIni_0159_0160; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> InitialState )
    private Com_0159_0161 oCom_0159_0161; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Busy )
    private Lea_0159_0167 oLea_0159_0167; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >> Idle )

    public Reg_0158_0159( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0159_0160 = new Ini_0159_0160( this );
      oCom_0159_0161 = new Com_0159_0161( this );
      oLea_0159_0167 = new Lea_0159_0167( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0159_0160;
      mStates[ 1 ] = oCom_0159_0161;
      mStates[ 2 ] = oLea_0159_0167;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0159_0160.ExecuteHandler( oHandler );
    }

     // At: ( FanServerPsm >> InitialState ) => ( FanServerPsm >> Idle )
    public void Tra_0159_0171( TsmHandler oHandler )
    {
      mCurrentState = oLea_0159_0167; // At: ( FanServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( FanServerPsm >> Busy ) => ( FanServerPsm >> Idle )
    public void Tra_0159_0170( TsmHandler oHandler )
    {
      mCurrentState = oLea_0159_0167; // At: ( FanServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> Low )
    public void Tra_0159_0168( TsmHandler oHandler )
    {
      mCurrentState = oCom_0159_0161; // At: ( FanServerPsm >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( FanServerPsm >> Idle ) => ( FanServerPsm >> Busy >> High )
    public void Tra_0159_0169( TsmHandler oHandler )
    {
      mCurrentState = oCom_0159_0161; // At: ( FanServerPsm >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 157:
        switch ( Command )
        {
        case 19:
          return TsmProspect.OK;
        case 20:
          return TsmProspect.OK;
        case 21:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 171:
        Tra_0159_0171( oHandler );
        break;
      case 170:
        Tra_0159_0170( oHandler );
        break;
      case 168:
        Tra_0159_0168( oHandler );
        break;
      case 169:
        Tra_0159_0169( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm )
  public class Fsm_0156_0158 : TsmFsm
  {
    private Reg_0158_0159 oReg_0158_0159; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm >)

    public Fsm_0156_0158( TsmBase oParent )
    {
      TsmName = "FanServerPsm";
      TsmParent = oParent;
      oReg_0158_0159 = new Reg_0158_0159( this );
      mRegions.Add( oReg_0158_0159 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanServer )
  public class Cla_0155_0156 : TsmProtocolClass
  {
    private Fsm_0156_0158 oFsm_0156_0158; // ( Xmi > Data > Protocols > FanProtocol > FanServer > FanServerPsm )
    private TsmIPort_IFan TsmPI__Port; // ( Xmi > Data > Protocols > FanProtocol > FanServer > Port )
    private TsmPSPort mPSMessager;

    public Cla_0155_0156( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0156_0158 = new Fsm_0156_0158( this );
      TsmPI__Port = new TsmIPort_IFan( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0156_0158;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > FanProtocol > FanServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0156_0158.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 157;
      TsmPI__Port.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0156_0158.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> InitialState )
  public class Ini_0175_0176 : TsmPseudo
  {
    public Ini_0175_0176( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 187, "( FanClientPsm >> InitialState ) => ( FanClientPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 187; // TRLS ( FanClientPsm >> InitialState ) => ( FanClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 187: // UP: ( FanClientPsm >> InitialState ) => ( FanClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >> Low )
  public class Lea_0178_0179 : TsmLeaf
  {
    int [] aNatives = { -181 };

    public Lea_0178_0179( TsmBase oParent )
    {
      TsmName = "Low";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 181, "( FanClientPsm >> Busy >> Low ) => ( FanClientPsm >> Busy >> High )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0178_0182( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0175_0184( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 181:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 181: // Native: ( FanClientPsm >> Busy >> Low ) => ( FanClientPsm >> Busy >> High )
          TsmRecorder.AddNative( "( FanClientPsm >> Busy >> Low ) => ( FanClientPsm >> Busy >> High ) # ToHigh();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 181;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 181: // UP: ( FanClientPsm >> Busy >> Low ) => ( FanClientPsm >> Busy >> High )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 182:
        Tra_0178_0182( oHandler );
        break;
      case 184:
        Tra_0175_0184( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >> High )
  public class Lea_0178_0180 : TsmLeaf
  {
    int [] aNatives = { -182 };

    public Lea_0178_0180( TsmBase oParent )
    {
      TsmName = "High";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 182, "( FanClientPsm >> Busy >> High ) => ( FanClientPsm >> Busy >> Low )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0178_0181( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0175_0185( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 182:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 182: // Native: ( FanClientPsm >> Busy >> High ) => ( FanClientPsm >> Busy >> Low )
          TsmRecorder.AddNative( "( FanClientPsm >> Busy >> High ) => ( FanClientPsm >> Busy >> Low ) # ToLow();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 182;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 181:
        Tra_0178_0181( oHandler );
        break;
      case 182: // UP: ( FanClientPsm >> Busy >> High ) => ( FanClientPsm >> Busy >> Low )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 185:
        Tra_0175_0185( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >)
  public class Reg_0177_0178 : TsmRegion
  {
    private Lea_0178_0179 oLea_0178_0179; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >> Low )
    private Lea_0178_0180 oLea_0178_0180; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >> High )

    public Reg_0177_0178( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oLea_0178_0179 = new Lea_0178_0179( this );
      oLea_0178_0180 = new Lea_0178_0180( this );
      mNrStates = 2;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oLea_0178_0179;
      mStates[ 1 ] = oLea_0178_0180;
    }

     // At: ( FanClientPsm >> Busy >> Low ) => ( FanClientPsm >> Busy >> High )
    public void Tra_0178_0181( TsmHandler oHandler )
    {
      ((Cla_0155_0172)oHandler.Owner).Function_1059( oHandler );
      mCurrentState = oLea_0178_0180; // At: ( FanClientPsm >> Busy >> High )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( FanClientPsm >> Busy >> High ) => ( FanClientPsm >> Busy >> Low )
    public void Tra_0178_0182( TsmHandler oHandler )
    {
      ((Cla_0155_0172)oHandler.Owner).Function_1060( oHandler );
      mCurrentState = oLea_0178_0179; // At: ( FanClientPsm >> Busy >> Low )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // Down: ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> Low )
    public void Tra_0175_0184( TsmHandler oHandler )
    {
      mCurrentState = oLea_0178_0179; // Down: ( FanClientPsm >> Busy >> Low )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // Down: ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> High )
    public void Tra_0175_0185( TsmHandler oHandler )
    {
      mCurrentState = oLea_0178_0180; // Down: ( FanClientPsm >> Busy >> High )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 181:
          return TsmProspect.OK;
        case 182:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 181:
        Tra_0178_0181( oHandler );
        break;
      case 182:
        Tra_0178_0182( oHandler );
        break;
      case 184:
        Tra_0175_0184( oHandler );
        break;
      case 185:
        Tra_0175_0185( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy )
  public class Com_0175_0177 : TsmCompound
  {
    int [] aNatives = { -186 };
    private Reg_0177_0178 oReg_0177_0178; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy >)

    public Com_0175_0177( TsmBase oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      oReg_0177_0178 = new Reg_0177_0178( this );
      mRegions.Add( oReg_0177_0178 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 186, "( FanClientPsm >> Busy ) => ( FanClientPsm >> Idle )" );
    }

    public void Tra_0175_0184( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oReg_0177_0178.ExecuteHandler( oHandler );
    }

    public void Tra_0175_0185( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oReg_0177_0178.ExecuteHandler( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtMyExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 186:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 186: // Native: ( FanClientPsm >> Busy ) => ( FanClientPsm >> Idle )
          TsmRecorder.AddNative( "( FanClientPsm >> Busy ) => ( FanClientPsm >> Idle ) # Stop();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 186;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 186: // UP: ( FanClientPsm >> Busy ) => ( FanClientPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 184:
        Tra_0175_0184( oHandler );
        break;
      case 185:
        Tra_0175_0185( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Idle )
  public class Lea_0175_0183 : TsmLeaf
  {
    int [] aNatives = { -184, -185 };

    public Lea_0175_0183( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 184, "( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> Low )" );
      mTransitions[ 1 ] = new TsmTransition( 185, "( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> High )" );
    }

    public void Tra_0175_0187( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0175_0186( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 184:
          return TsmProspect.OK;
        case 185:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 184: // Native: ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> Low )
          TsmRecorder.AddNative( "( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> Low ) # ToLow();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 184;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        case 185: // Native: ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> High )
          TsmRecorder.AddNative( "( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> High ) # ToHigh();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 185;
          oHandler.bTaken = true;
          mTransitions[ 1 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 187:
        Tra_0175_0187( oHandler );
        break;
      case 186:
        Tra_0175_0186( oHandler );
        break;
      case 184: // UP: ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> Low )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 185: // UP: ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> High )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >)
  public class Reg_0174_0175 : TsmRegion
  {
    private Ini_0175_0176 oIni_0175_0176; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> InitialState )
    private Com_0175_0177 oCom_0175_0177; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Busy )
    private Lea_0175_0183 oLea_0175_0183; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >> Idle )

    public Reg_0174_0175( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0175_0176 = new Ini_0175_0176( this );
      oCom_0175_0177 = new Com_0175_0177( this );
      oLea_0175_0183 = new Lea_0175_0183( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0175_0176;
      mStates[ 1 ] = oCom_0175_0177;
      mStates[ 2 ] = oLea_0175_0183;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0175_0176.ExecuteHandler( oHandler );
    }

     // At: ( FanClientPsm >> InitialState ) => ( FanClientPsm >> Idle )
    public void Tra_0175_0187( TsmHandler oHandler )
    {
      mCurrentState = oLea_0175_0183; // At: ( FanClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( FanClientPsm >> Busy ) => ( FanClientPsm >> Idle )
    public void Tra_0175_0186( TsmHandler oHandler )
    {
      ((Cla_0155_0172)oHandler.Owner).Function_1058( oHandler );
      mCurrentState = oLea_0175_0183; // At: ( FanClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> Low )
    public void Tra_0175_0184( TsmHandler oHandler )
    {
      ((Cla_0155_0172)oHandler.Owner).Function_1061( oHandler );
      mCurrentState = oCom_0175_0177; // At: ( FanClientPsm >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> High )
    public void Tra_0175_0185( TsmHandler oHandler )
    {
      ((Cla_0155_0172)oHandler.Owner).Function_1062( oHandler );
      mCurrentState = oCom_0175_0177; // At: ( FanClientPsm >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 186:
          return TsmProspect.OK;
        case 181:
          return TsmProspect.OK;
        case 182:
          return TsmProspect.OK;
        case 184:
          return TsmProspect.OK;
        case 185:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 187:
        Tra_0175_0187( oHandler );
        break;
      case 186:
        Tra_0175_0186( oHandler );
        break;
      case 184:
        Tra_0175_0184( oHandler );
        break;
      case 185:
        Tra_0175_0185( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm )
  public class Fsm_0172_0174 : TsmFsm
  {
    private Reg_0174_0175 oReg_0174_0175; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm >)

    public Fsm_0172_0174( TsmBase oParent )
    {
      TsmName = "FanClientPsm";
      TsmParent = oParent;
      oReg_0174_0175 = new Reg_0174_0175( this );
      mRegions.Add( oReg_0174_0175 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > FanProtocol > FanClient )
  public class Cla_0155_0172 : TsmProtocolClass
  {
    private Fsm_0172_0174 oFsm_0172_0174; // ( Xmi > Data > Protocols > FanProtocol > FanClient > FanClientPsm )
    private TsmIPort_IFan Port; // ( Xmi > Data > Protocols > FanProtocol > FanClient > Port )

    public Cla_0155_0172( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0172_0174 = new Fsm_0172_0174( this );
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0172_0174;
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_IFan) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > FanProtocol > FanClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0172_0174.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( FanClientPsm >> Busy ) => ( FanClientPsm >> Idle )
    public void Function_1058( TsmHandler oHandler )
    {
      Port.Stop();
    }

     // ( FanClientPsm >> Busy >> Low ) => ( FanClientPsm >> Busy >> High )
    public void Function_1059( TsmHandler oHandler )
    {
      Port.ToHigh();
    }

     // ( FanClientPsm >> Busy >> High ) => ( FanClientPsm >> Busy >> Low )
    public void Function_1060( TsmHandler oHandler )
    {
      Port.ToLow();
    }

     // ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> Low )
    public void Function_1061( TsmHandler oHandler )
    {
      Port.ToLow();
    }

     // ( FanClientPsm >> Idle ) => ( FanClientPsm >> Busy >> High )
    public void Function_1062( TsmHandler oHandler )
    {
      Port.ToHigh();
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0172_0174.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > FanProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > FanProtocol )
  public class Pac_0002_0155 : TsmPackage
  {
    public Pac_0002_0155( TsmBase oParent )
    {
      TsmName = "FanProtocol";
      TsmParent = oParent;
    }
  }

  public interface INvm
  {
    int GetTarget();
    void SetTarget( int Target );
    FanLevel GetFanLevel();
    void SetFanLevel( FanLevel Level );
  }

  public class TsmTrigger_INvm___GetTarget : TsmTrigger
  {
    public int _RetVal;

    public TsmTrigger_INvm___GetTarget()
      : base( 22 )
    {
    }
  }

  public class TsmTrigger_INvm___SetTarget : TsmTrigger
  {
    public int Target;

    public TsmTrigger_INvm___SetTarget( int Target )
      : base( 23 )
    {
      this.Target = Target;
    }
  }

  public class TsmTrigger_INvm___GetFanLevel : TsmTrigger
  {
    public FanLevel _RetVal;

    public TsmTrigger_INvm___GetFanLevel()
      : base( 24 )
    {
    }
  }

  public class TsmTrigger_INvm___SetFanLevel : TsmTrigger
  {
    public FanLevel Level;

    public TsmTrigger_INvm___SetFanLevel( FanLevel Level )
      : base( 25 )
    {
      this.Level = Level;
    }
  }

   // ( Xmi > Data > Protocols > NvmProtocol > INvm )
  public class TsmIPort_INvm : TsmInterfacePort, INvm
  {
    public TsmIPort_INvm( TsmBase oParent )
    {
      TsmName = "INvm";
      TsmParent = oParent;
    }

    public virtual int GetTarget()
    {
      TsmTrigger_INvm___GetTarget tt = new TsmTrigger_INvm___GetTarget();
      TsmRecorder.AddCall( "GetTarget", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
      return tt._RetVal;
    }

    public virtual void SetTarget( int Target )
    {
      TsmTrigger_INvm___SetTarget tt = new TsmTrigger_INvm___SetTarget( Target );
      TsmRecorder.AddCall( "SetTarget", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual FanLevel GetFanLevel()
    {
      TsmTrigger_INvm___GetFanLevel tt = new TsmTrigger_INvm___GetFanLevel();
      TsmRecorder.AddCall( "GetFanLevel", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
      return tt._RetVal;
    }

    public virtual void SetFanLevel( FanLevel Level )
    {
      TsmTrigger_INvm___SetFanLevel tt = new TsmTrigger_INvm___SetFanLevel( Level );
      TsmRecorder.AddCall( "SetFanLevel", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > NvmProtocol > NvmClient )
  public class Cla_0188_0189 : TsmProtocolClass
  {
    private TsmIPort_INvm Port; // ( Xmi > Data > Protocols > NvmProtocol > NvmClient > Port )

    public Cla_0188_0189( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_INvm) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > NvmProtocol > NvmClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      SnapCall = "";
      SnapState = null;
    }
  }

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> InitialState )
  public class Ini_0194_0195 : TsmPseudo
  {
    public Ini_0194_0195( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 199, "( NvmServerFsm >> InitialState ) => ( NvmServerFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 199; // TRLS ( NvmServerFsm >> InitialState ) => ( NvmServerFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 199: // UP: ( NvmServerFsm >> InitialState ) => ( NvmServerFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> ChoiceState )
  public class Cho_0194_0196 : TsmPseudo
  {
    private int MaxNrChoices = 2;

    public Cho_0194_0196( TsmBase oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 201, "( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 202, "( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "low level" ) )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 201; // TRLS ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        mTransitions[ 0 ].bVisit = true;
      }
      else
      if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 202; // TRLS ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        mTransitions[ 1 ].bVisit = true;
      }
    }

    public void Tra_0194_0200( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 201: // UP: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        bHigher = true;
        break;
      case 202: // UP: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        bHigher = true;
        break;
      case 200:
        Tra_0194_0200( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> ChoiceState )
  public class Cho_0194_0197 : TsmPseudo
  {
    private int MaxNrChoices = 2;

    public Cho_0194_0197( TsmBase oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 205, "( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 206, "( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "low target" ) )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 205; // TRLS ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        mTransitions[ 0 ].bVisit = true;
      }
      else
      if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 206; // TRLS ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        mTransitions[ 1 ].bVisit = true;
      }
    }

    public void Tra_0194_0204( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 205: // UP: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        bHigher = true;
        break;
      case 206: // UP: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
        bHigher = true;
        break;
      case 204:
        Tra_0194_0204( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> Idle )
  public class Lea_0194_0198 : TsmLeaf
  {
    public Lea_0194_0198( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 204, "( NvmServerFsm >> Idle ) => ( NvmServerFsm >> ChoiceState ) : GetTarget" );
      mTransitions[ 1 ] = new TsmTransition( 207, "( NvmServerFsm >> Idle ) => ( NvmServerFsm >> Idle ) : SetTarget" );
      mTransitions[ 2 ] = new TsmTransition( 200, "( NvmServerFsm >> Idle ) => ( NvmServerFsm >> ChoiceState ) : GetFanLevel" );
      mTransitions[ 3 ] = new TsmTransition( 203, "( NvmServerFsm >> Idle ) => ( NvmServerFsm >> Idle ) : SetFanLevel" );
    }

    public void Tra_0194_0199( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0194_0201( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0194_0202( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0194_0205( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0194_0206( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Port___GetTarget( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 204; // GetTarget
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0194_0207( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void Port___SetTarget( int Target, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 207; // SetTarget
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public void Port___GetFanLevel( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 200; // GetFanLevel
      oHandler.bTaken = true;
      mTransitions[ 2 ].bVisit = true;
    }

    public void Tra_0194_0203( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void Port___SetFanLevel( FanLevel Level, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 203; // SetFanLevel
      oHandler.bTaken = true;
      mTransitions[ 3 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 192:
        switch ( Command )
        {
        case 22:
          return TsmProspect.OK;
        case 23:
          return TsmProspect.OK;
        case 24:
          return TsmProspect.OK;
        case 25:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 192: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 22: // Port___GetTarget
          {
            Port___GetTarget( oHandler );
          }
          break;
        case 23: // Port___SetTarget
          {
            TsmTrigger_INvm___SetTarget lTrigger = (TsmTrigger_INvm___SetTarget) oHandler.Trigger;

            Port___SetTarget( lTrigger.Target, oHandler );
          }
          break;
        case 24: // Port___GetFanLevel
          {
            Port___GetFanLevel( oHandler );
          }
          break;
        case 25: // Port___SetFanLevel
          {
            TsmTrigger_INvm___SetFanLevel lTrigger = (TsmTrigger_INvm___SetFanLevel) oHandler.Trigger;

            Port___SetFanLevel( lTrigger.Level, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 199:
        Tra_0194_0199( oHandler );
        break;
      case 201:
        Tra_0194_0201( oHandler );
        break;
      case 202:
        Tra_0194_0202( oHandler );
        break;
      case 205:
        Tra_0194_0205( oHandler );
        break;
      case 206:
        Tra_0194_0206( oHandler );
        break;
      case 204: // UP: ( NvmServerFsm >> Idle ) => ( NvmServerFsm >> ChoiceState )
        bHigher = true;
        break;
      case 207:
        Tra_0194_0207( oHandler );
        break;
      case 200: // UP: ( NvmServerFsm >> Idle ) => ( NvmServerFsm >> ChoiceState )
        bHigher = true;
        break;
      case 203:
        Tra_0194_0203( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >)
  public class Reg_0193_0194 : TsmRegion
  {
    private Ini_0194_0195 oIni_0194_0195; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> InitialState )
    private Cho_0194_0196 oCho_0194_0196; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> ChoiceState )
    private Cho_0194_0197 oCho_0194_0197; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> ChoiceState )
    private Lea_0194_0198 oLea_0194_0198; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >> Idle )

    public Reg_0193_0194( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0194_0195 = new Ini_0194_0195( this );
      oCho_0194_0196 = new Cho_0194_0196( this );
      oCho_0194_0197 = new Cho_0194_0197( this );
      oLea_0194_0198 = new Lea_0194_0198( this );
      mNrStates = 4;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0194_0195;
      mStates[ 1 ] = oCho_0194_0196;
      mStates[ 2 ] = oCho_0194_0197;
      mStates[ 3 ] = oLea_0194_0198;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0194_0195.ExecuteHandler( oHandler );
    }

     // At: ( NvmServerFsm >> InitialState ) => ( NvmServerFsm >> Idle )
    public void Tra_0194_0199( TsmHandler oHandler )
    {
      mCurrentState = oLea_0194_0198; // At: ( NvmServerFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public void Tra_0194_0201( TsmHandler oHandler )
    {
      ((Cla_0188_0191)oHandler.Owner).Function_1011( oHandler );
      mCurrentState = oLea_0194_0198; // At: ( NvmServerFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public void Tra_0194_0202( TsmHandler oHandler )
    {
      ((Cla_0188_0191)oHandler.Owner).Function_1013( oHandler );
      mCurrentState = oLea_0194_0198; // At: ( NvmServerFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public void Tra_0194_0205( TsmHandler oHandler )
    {
      ((Cla_0188_0191)oHandler.Owner).Function_1015( oHandler );
      mCurrentState = oLea_0194_0198; // At: ( NvmServerFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public void Tra_0194_0206( TsmHandler oHandler )
    {
      ((Cla_0188_0191)oHandler.Owner).Function_1017( oHandler );
      mCurrentState = oLea_0194_0198; // At: ( NvmServerFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( NvmServerFsm >> Idle ) => ( NvmServerFsm >> ChoiceState )
    public void Tra_0194_0204( TsmHandler oHandler )
    {
      mCurrentState = oCho_0194_0197; // At: ( NvmServerFsm >> ChoiceState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( NvmServerFsm >> Idle ) => ( NvmServerFsm >> ChoiceState )
    public void Tra_0194_0200( TsmHandler oHandler )
    {
      mCurrentState = oCho_0194_0196; // At: ( NvmServerFsm >> ChoiceState )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 192:
        switch ( Command )
        {
        case 22:
          return TsmProspect.OK;
        case 23:
          return TsmProspect.OK;
        case 24:
          return TsmProspect.OK;
        case 25:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 199:
        Tra_0194_0199( oHandler );
        break;
      case 201:
        Tra_0194_0201( oHandler );
        break;
      case 202:
        Tra_0194_0202( oHandler );
        break;
      case 205:
        Tra_0194_0205( oHandler );
        break;
      case 206:
        Tra_0194_0206( oHandler );
        break;
      case 204:
        Tra_0194_0204( oHandler );
        break;
      case 200:
        Tra_0194_0200( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm )
  public class Fsm_0191_0193 : TsmFsm
  {
    private Reg_0193_0194 oReg_0193_0194; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm >)

    public Fsm_0191_0193( TsmBase oParent )
    {
      TsmName = "NvmServerFsm";
      TsmParent = oParent;
      oReg_0193_0194 = new Reg_0193_0194( this );
      mRegions.Add( oReg_0193_0194 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > NvmProtocol > NvmServer )
  public class Cla_0188_0191 : TsmProtocolClass
  {
    private Fsm_0191_0193 oFsm_0191_0193; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > NvmServerFsm )
    private TsmIPort_INvm TsmPI__Port; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > Port )
    private TsmPSPort mPSMessager;

    public Cla_0188_0191( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0191_0193 = new Fsm_0191_0193( this );
      TsmPI__Port = new TsmIPort_INvm( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0191_0193;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > NvmProtocol > NvmServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0191_0193.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public FanLevel Function_1010()
    {
      return FanLevel.LOW;
    }

     // ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public void Function_1011( TsmHandler oHandler )
    {
      TsmTrigger_INvm___GetFanLevel lTrigger = (TsmTrigger_INvm___GetFanLevel) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0188_0191)oHandler.Owner).Function_1010();
    }

     // ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public FanLevel Function_1012()
    {
      return FanLevel.HIGH;
    }

     // ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public void Function_1013( TsmHandler oHandler )
    {
      TsmTrigger_INvm___GetFanLevel lTrigger = (TsmTrigger_INvm___GetFanLevel) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0188_0191)oHandler.Owner).Function_1012();
    }

     // ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public int Function_1014()
    {
      return 18;
    }

     // ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public void Function_1015( TsmHandler oHandler )
    {
      TsmTrigger_INvm___GetTarget lTrigger = (TsmTrigger_INvm___GetTarget) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0188_0191)oHandler.Owner).Function_1014();
    }

     // ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public int Function_1016()
    {
      return 22;
    }

     // ( NvmServerFsm >> ChoiceState ) => ( NvmServerFsm >> Idle )
    public void Function_1017( TsmHandler oHandler )
    {
      TsmTrigger_INvm___GetTarget lTrigger = (TsmTrigger_INvm___GetTarget) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0188_0191)oHandler.Owner).Function_1016();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 192;
      TsmPI__Port.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0191_0193.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > NvmProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > NvmProtocol )
  public class Pac_0002_0188 : TsmPackage
  {
    public Pac_0002_0188( TsmBase oParent )
    {
      TsmName = "NvmProtocol";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols )
   ********************************************************************/

   // ( Xmi > Data > Protocols )
  public class Pac_0001_0002 : TsmPackage
  {
    public Pac_0001_0002( TsmBase oParent )
    {
      TsmName = "Protocols";
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> InitialState )
  public class Ini_0234_0235 : TsmPseudo
  {
    public Ini_0234_0235( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 269, "( AircoFsm >> InitialState ) => ( AircoFsm >> Standby )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 269; // TRLS ( AircoFsm >> InitialState ) => ( AircoFsm >> Standby )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 269: // UP: ( AircoFsm >> InitialState ) => ( AircoFsm >> Standby )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > InitialState )
  public class Ini_0237_0238 : TsmPseudo
  {
    public Ini_0237_0238( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 245, "( AircoFsm >> Active > Cooler > InitialState ) => ( AircoFsm >> Active > Cooler > Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 245; // TRLS ( AircoFsm >> Active > Cooler > InitialState ) => ( AircoFsm >> Active > Cooler > Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 245: // UP: ( AircoFsm >> Active > Cooler > InitialState ) => ( AircoFsm >> Active > Cooler > Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > FinalState )
  public class Fin_0237_0239 : TsmFinal
  {
    public Fin_0237_0239( TsmBase oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public void Tra_0237_0249( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0237_0250( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 249:
        Tra_0237_0249( oHandler );
        break;
      case 250:
        Tra_0237_0250( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling > ConnExitRef )
  public class Con_0240_0241 : TsmState
  {
    public Con_0240_0241( TsmBase oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 248, "( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 248; // TRLS ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 248: // UP: ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling > ConnExitRef )
  public class Con_0240_0242 : TsmState
  {
    public Con_0240_0242( TsmBase oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 249, "( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > FinalState )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 249; // TRLS ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > FinalState )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 249: // UP: ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > FinalState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> InitialState )
  public class Ini_0273_0274 : TsmPseudo
  {
    public Ini_0273_0274( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 313, "( AircoFsm > CoolingSubFsm >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 313; // TRLS ( AircoFsm > CoolingSubFsm >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 313: // UP: ( AircoFsm > CoolingSubFsm >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> InitialState )
  public class Ini_0321_0322 : TsmPseudo
  {
    public Ini_0321_0322( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 325, "( AircoFsm > StoppingSubFsm >> InitialState ) => ( AircoFsm > StoppingSubFsm >> Wait )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 325; // TRLS ( AircoFsm > StoppingSubFsm >> InitialState ) => ( AircoFsm > StoppingSubFsm >> Wait )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 325: // UP: ( AircoFsm > StoppingSubFsm >> InitialState ) => ( AircoFsm > StoppingSubFsm >> Wait )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> FinalState )
  public class Fin_0321_0323 : TsmFinal
  {
    public Fin_0321_0323( TsmBase oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public void Tra_0321_0328( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 328:
        Tra_0321_0328( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> Wait )
  public class Lea_0321_0324 : TsmLeaf
  {
    public Lea_0321_0324( TsmBase oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 3;
      mTransitions = new TsmTransition[ 3 ];
      mTransitions[ 0 ] = new TsmTransition( 326, "( AircoFsm > StoppingSubFsm >> Wait ) => ( AircoFsm > StoppingSubFsm >> Wait ) : rp_sensor->CbAbove" );
      mTransitions[ 1 ] = new TsmTransition( 327, "( AircoFsm > StoppingSubFsm >> Wait ) => ( AircoFsm > StoppingSubFsm >> Wait ) : rp_sensor->CbBelow" );
      mTransitions[ 2 ] = new TsmTransition( 328, "( AircoFsm > StoppingSubFsm >> Wait ) => ( AircoFsm > StoppingSubFsm >> FinalState ) : rp_sensor->CbStopped" );
    }

    public void Tra_0321_0325( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0321_0326( TsmHandler oHandler )
    {
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void rp_sensor___CbAbove( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 326; // rp_sensor.CbAbove
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0321_0327( TsmHandler oHandler )
    {
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void rp_sensor___CbBelow( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 327; // rp_sensor.CbBelow
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public void rp_sensor___CbStopped( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 328; // rp_sensor.CbStopped
      oHandler.bTaken = true;
      mTransitions[ 2 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 232:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 11:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 232: // Port rp_sensor
        switch ( oHandler.Trigger.Command )
        {
        case 10: // rp_sensor___CbAbove
          {
            rp_sensor___CbAbove( oHandler );
          }
          break;
        case 11: // rp_sensor___CbBelow
          {
            rp_sensor___CbBelow( oHandler );
          }
          break;
        case 12: // rp_sensor___CbStopped
          {
            rp_sensor___CbStopped( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 325:
        Tra_0321_0325( oHandler );
        break;
      case 326:
        Tra_0321_0326( oHandler );
        break;
      case 327:
        Tra_0321_0327( oHandler );
        break;
      case 328: // UP: ( AircoFsm > StoppingSubFsm >> Wait ) => ( AircoFsm > StoppingSubFsm >> FinalState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >)
  public class Reg_0320_0321 : TsmRegion
  {
    private Ini_0321_0322 oIni_0321_0322; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> InitialState )
    private Fin_0321_0323 oFin_0321_0323; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> FinalState )
    private Lea_0321_0324 oLea_0321_0324; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >> Wait )

    public Reg_0320_0321( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0321_0322 = new Ini_0321_0322( this );
      oFin_0321_0323 = new Fin_0321_0323( this );
      oLea_0321_0324 = new Lea_0321_0324( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0321_0322;
      mStates[ 1 ] = oFin_0321_0323;
      mStates[ 2 ] = oLea_0321_0324;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0321_0322.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > StoppingSubFsm >> InitialState ) => ( AircoFsm > StoppingSubFsm >> Wait )
    public void Tra_0321_0325( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1039( oHandler );
      mCurrentState = oLea_0321_0324; // At: ( AircoFsm > StoppingSubFsm >> Wait )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > StoppingSubFsm >> Wait ) => ( AircoFsm > StoppingSubFsm >> FinalState )
    public void Tra_0321_0328( TsmHandler oHandler )
    {
      mCurrentState = oFin_0321_0323; // At: ( AircoFsm > StoppingSubFsm >> FinalState )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 232:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 11:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 325:
        Tra_0321_0325( oHandler );
        break;
      case 328:
        Tra_0321_0328( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm )
  public class Fsm_0233_0320 : TsmFsm
  {
    private Reg_0320_0321 oReg_0320_0321; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm >)

    public Fsm_0233_0320( TsmBase oParent )
    {
      TsmName = "StoppingSubFsm";
      TsmParent = oParent;
      oReg_0320_0321 = new Reg_0320_0321( this );
      mRegions.Add( oReg_0320_0321 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> OffStopping )
  public class Sub_0273_0275 : TsmSubFsm
  {
    public Sub_0273_0275( TsmBase oParent )
    {
      TsmName = "OffStopping";
      TsmParent = oParent;
      oFsm = new Fsm_0233_0320( this ); // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm )
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 315, "( AircoFsm > CoolingSubFsm >> OffStopping ) => ( AircoFsm > CoolingSubFsm > ExitOff )" );
    }

    public override void ExecuteTriggerless( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 315; // TRLS ( AircoFsm > CoolingSubFsm >> OffStopping ) => ( AircoFsm > CoolingSubFsm > ExitOff )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0273_0314( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oHandler.Action = TsmHandlerAction.ENTER;
      oFsm.ExecuteHandler( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 315: // UP: ( AircoFsm > CoolingSubFsm >> OffStopping ) => ( AircoFsm > CoolingSubFsm > ExitOff )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 314:
        Tra_0273_0314( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Stopping )
  public class Sub_0273_0276 : TsmSubFsm
  {
    public Sub_0273_0276( TsmBase oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      oFsm = new Fsm_0233_0320( this ); // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > StoppingSubFsm )
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 317, "( AircoFsm > CoolingSubFsm >> Stopping ) => ( AircoFsm > CoolingSubFsm > ExitStop )" );
    }

    public override void ExecuteTriggerless( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 317; // TRLS ( AircoFsm > CoolingSubFsm >> Stopping ) => ( AircoFsm > CoolingSubFsm > ExitStop )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0273_0316( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oHandler.Action = TsmHandlerAction.ENTER;
      oFsm.ExecuteHandler( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 317: // UP: ( AircoFsm > CoolingSubFsm >> Stopping ) => ( AircoFsm > CoolingSubFsm > ExitStop )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 316:
        Tra_0273_0316( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> InitialState )
  public class Ini_0278_0279 : TsmPseudo
  {
    public Ini_0278_0279( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 308, "( AircoFsm > CoolingSubFsm >> Composite >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 308; // TRLS ( AircoFsm > CoolingSubFsm >> Composite >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 308: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> JuncState )
  public class Jun_0278_0280 : TsmPseudo
  {
    public Jun_0278_0280( TsmBase oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 309, "( AircoFsm > CoolingSubFsm >> Composite >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )" );
    }

    public void Tra_0278_0308( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 309; // TRLS ( AircoFsm > CoolingSubFsm >> Composite >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0278_0311( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 308:
        Tra_0278_0308( oHandler );
        break;
      case 309: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )
        bHigher = true;
        break;
      case 311:
        Tra_0278_0311( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )
  public class Cho_0278_0281 : TsmPseudo
  {
    public Cho_0278_0281( TsmBase oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 310, "( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )" );
      mTransitions[ 1 ] = new TsmTransition( 312, "( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )" );
    }

    public void Tra_0278_0309( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      if ( ((Cla_0225_0227)oHandler.Owner).Guard_1033() )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 310; // TRLS ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        mTransitions[ 0 ].bVisit = true;
      }
      else
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 312; // TRLS ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
        mTransitions[ 1 ].bVisit = true;
      }
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 309:
        Tra_0278_0309( oHandler );
        break;
      case 310: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        bHigher = true;
        break;
      case 312: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> InitialState )
  public class Ini_0283_0284 : TsmPseudo
  {
    public Ini_0283_0284( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 288, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 288; // TRLS ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 288: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> FinalState )
  public class Fin_0283_0285 : TsmFinal
  {
    public Fin_0283_0285( TsmBase oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public void Tra_0283_0290( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 290:
        Tra_0283_0290( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )
  public class Lea_0283_0286 : TsmLeaf
  {
    public Lea_0283_0286( TsmBase oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 289, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) : pp_airco->SetTarget" );
      mTransitions[ 1 ] = new TsmTransition( 292, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling ) : rp_sensor->CbAbove" );
    }

    public void Tra_0283_0288( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void pp_airco___SetTarget( int Target, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 289; // pp_airco.SetTarget
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void rp_sensor___CbAbove( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 292; // rp_sensor.CbAbove
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 5:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 228
      case 232:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 228: // Port pp_airco
        switch ( oHandler.Trigger.Command )
        {
        case 5: // pp_airco___SetTarget
          {
            TsmTrigger_IAirco___SetTarget lTrigger = (TsmTrigger_IAirco___SetTarget) oHandler.Trigger;

            pp_airco___SetTarget( lTrigger.Target, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break; // end of Port 228
      case 232: // Port rp_sensor
        switch ( oHandler.Trigger.Command )
        {
        case 10: // rp_sensor___CbAbove
          {
            rp_sensor___CbAbove( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 288:
        Tra_0283_0288( oHandler );
        break;
      case 289: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping )
        bHigher = true;
        break;
      case 292: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping )
  public class Lea_0283_0287 : TsmLeaf
  {
    public Lea_0283_0287( TsmBase oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 291, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) : rp_sensor->CbAbove" );
      mTransitions[ 1 ] = new TsmTransition( 290, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> FinalState ) : rp_sensor->CbStopped" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0283_0289( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0283_0291( TsmHandler oHandler )
    {
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void rp_sensor___CbAbove( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 291; // rp_sensor.CbAbove
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void rp_sensor___CbStopped( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 290; // rp_sensor.CbStopped
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 232:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 232: // Port rp_sensor
        switch ( oHandler.Trigger.Command )
        {
        case 10: // rp_sensor___CbAbove
          {
            rp_sensor___CbAbove( oHandler );
          }
          break;
        case 12: // rp_sensor___CbStopped
          {
            rp_sensor___CbStopped( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 289:
        Tra_0283_0289( oHandler );
        break;
      case 291:
        Tra_0283_0291( oHandler );
        break;
      case 290: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> FinalState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >)
  public class Reg_0282_0283 : TsmRegion
  {
    private Ini_0283_0284 oIni_0283_0284; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> InitialState )
    private Fin_0283_0285 oFin_0283_0285; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> FinalState )
    private Lea_0283_0286 oLea_0283_0286; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )
    private Lea_0283_0287 oLea_0283_0287; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping )

    public Reg_0282_0283( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0283_0284 = new Ini_0283_0284( this );
      oFin_0283_0285 = new Fin_0283_0285( this );
      oLea_0283_0286 = new Lea_0283_0286( this );
      oLea_0283_0287 = new Lea_0283_0287( this );
      mNrStates = 4;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0283_0284;
      mStates[ 1 ] = oFin_0283_0285;
      mStates[ 2 ] = oLea_0283_0286;
      mStates[ 3 ] = oLea_0283_0287;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0283_0284.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )
    public void Tra_0283_0288( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1034( oHandler );
      mCurrentState = oLea_0283_0286; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping )
    public void Tra_0283_0289( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1069( oHandler );
      mCurrentState = oLea_0283_0287; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> FinalState )
    public void Tra_0283_0290( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1075( oHandler );
      mCurrentState = oFin_0283_0285; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> FinalState )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 5:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 228
      case 232:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 288:
        Tra_0283_0288( oHandler );
        break;
      case 289:
        Tra_0283_0289( oHandler );
        break;
      case 292: // Up: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
        mCurrentState = null;
        bHigher = true;
        break;
      case 290:
        Tra_0283_0290( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing )
  public class Com_0278_0282 : TsmCompound
  {
    private Reg_0282_0283 oReg_0282_0283; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing >)

    public Com_0278_0282( TsmBase oParent )
    {
      TsmName = "Sensing";
      TsmParent = oParent;
      oReg_0282_0283 = new Reg_0282_0283( this );
      mRegions.Add( oReg_0282_0283 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 311, "( AircoFsm > CoolingSubFsm >> Composite >> Sensing ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )" );
    }

    public void Tra_0278_0310( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void ExecuteTriggerless( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 311; // TRLS ( AircoFsm > CoolingSubFsm >> Composite >> Sensing ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0294_0307( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0294_0306( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 310:
        Tra_0278_0310( oHandler );
        break;
      case 311: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 307:
        Tra_0294_0307( oHandler );
        break;
      case 292: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 306:
        Tra_0294_0306( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> InitialState )
  public class Ini_0294_0295 : TsmPseudo
  {
    public Ini_0294_0295( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 301, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 301; // TRLS ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 301: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
  public class Jun_0294_0296 : TsmPseudo
  {
    public Jun_0294_0296( TsmBase oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 300, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )" );
    }

    public void Tra_0294_0301( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 300; // TRLS ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0294_0305( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 301:
        Tra_0294_0301( oHandler );
        break;
      case 300: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )
        bHigher = true;
        break;
      case 305:
        Tra_0294_0305( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState )
  public class Cho_0294_0297 : TsmPseudo
  {
    public Cho_0294_0297( TsmBase oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 307, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )" );
      mTransitions[ 1 ] = new TsmTransition( 305, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      if ( ((Cla_0225_0227)oHandler.Owner).Guard_1038() )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 307; // TRLS ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        mTransitions[ 0 ].bVisit = true;
      }
      else
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 305; // TRLS ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
        mTransitions[ 1 ].bVisit = true;
      }
    }

    public void Tra_0294_0304( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 307: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        bHigher = true;
        break;
      case 305: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
        bHigher = true;
        break;
      case 304:
        Tra_0294_0304( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )
  public class Lea_0294_0298 : TsmLeaf
  {
    public Lea_0294_0298( TsmBase oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 302, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) : pp_airco->SetTarget" );
      mTransitions[ 1 ] = new TsmTransition( 306, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing ) : rp_sensor->CbBelow" );
    }

    public void Tra_0294_0300( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void pp_airco___SetTarget( int Target, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 302; // pp_airco.SetTarget
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void rp_sensor___CbBelow( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 306; // rp_sensor.CbBelow
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 5:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 228
      case 232:
        switch ( Command )
        {
        case 11:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 228: // Port pp_airco
        switch ( oHandler.Trigger.Command )
        {
        case 5: // pp_airco___SetTarget
          {
            TsmTrigger_IAirco___SetTarget lTrigger = (TsmTrigger_IAirco___SetTarget) oHandler.Trigger;

            pp_airco___SetTarget( lTrigger.Target, oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break; // end of Port 228
      case 232: // Port rp_sensor
        switch ( oHandler.Trigger.Command )
        {
        case 11: // rp_sensor___CbBelow
          {
            rp_sensor___CbBelow( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 300:
        Tra_0294_0300( oHandler );
        break;
      case 302: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping )
        bHigher = true;
        break;
      case 306: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping )
  public class Lea_0294_0299 : TsmLeaf
  {
    public Lea_0294_0299( TsmBase oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 303, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) : rp_sensor->CbBelow" );
      mTransitions[ 1 ] = new TsmTransition( 304, "( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) : rp_sensor->CbStopped" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0294_0302( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0294_0303( TsmHandler oHandler )
    {
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void rp_sensor___CbBelow( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 303; // rp_sensor.CbBelow
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void rp_sensor___CbStopped( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 304; // rp_sensor.CbStopped
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 232:
        switch ( Command )
        {
        case 11:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 232: // Port rp_sensor
        switch ( oHandler.Trigger.Command )
        {
        case 11: // rp_sensor___CbBelow
          {
            rp_sensor___CbBelow( oHandler );
          }
          break;
        case 12: // rp_sensor___CbStopped
          {
            rp_sensor___CbStopped( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 302:
        Tra_0294_0302( oHandler );
        break;
      case 303:
        Tra_0294_0303( oHandler );
        break;
      case 304: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >)
  public class Reg_0293_0294 : TsmRegion
  {
    private Ini_0294_0295 oIni_0294_0295; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> InitialState )
    private Jun_0294_0296 oJun_0294_0296; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
    private Cho_0294_0297 oCho_0294_0297; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState )
    private Lea_0294_0298 oLea_0294_0298; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )
    private Lea_0294_0299 oLea_0294_0299; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping )

    public Reg_0293_0294( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0294_0295 = new Ini_0294_0295( this );
      oJun_0294_0296 = new Jun_0294_0296( this );
      oCho_0294_0297 = new Cho_0294_0297( this );
      oLea_0294_0298 = new Lea_0294_0298( this );
      oLea_0294_0299 = new Lea_0294_0299( this );
      mNrStates = 5;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0294_0295;
      mStates[ 1 ] = oJun_0294_0296;
      mStates[ 2 ] = oCho_0294_0297;
      mStates[ 3 ] = oLea_0294_0298;
      mStates[ 4 ] = oLea_0294_0299;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0294_0295.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
    public void Tra_0294_0301( TsmHandler oHandler )
    {
      mCurrentState = oJun_0294_0296; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )
    public void Tra_0294_0300( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1037( oHandler );
      mCurrentState = oLea_0294_0298; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
    public void Tra_0294_0305( TsmHandler oHandler )
    {
      mCurrentState = oJun_0294_0296; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping )
    public void Tra_0294_0302( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1070( oHandler );
      mCurrentState = oLea_0294_0299; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState )
    public void Tra_0294_0304( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1076( oHandler );
      mCurrentState = oCho_0294_0297; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 5:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 228
      case 232:
        switch ( Command )
        {
        case 11:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 301:
        Tra_0294_0301( oHandler );
        break;
      case 300:
        Tra_0294_0300( oHandler );
        break;
      case 307: // Up: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        mCurrentState = null;
        bHigher = true;
        break;
      case 305:
        Tra_0294_0305( oHandler );
        break;
      case 302:
        Tra_0294_0302( oHandler );
        break;
      case 306: // Up: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        mCurrentState = null;
        bHigher = true;
        break;
      case 304:
        Tra_0294_0304( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling )
  public class Com_0278_0293 : TsmCompound
  {
    private Reg_0293_0294 oReg_0293_0294; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling >)

    public Com_0278_0293( TsmBase oParent )
    {
      TsmName = "Cooling";
      TsmParent = oParent;
      oReg_0293_0294 = new Reg_0293_0294( this );
      mRegions.Add( oReg_0293_0294 );
      mNrTransitions = 0;
    }

    public void Tra_0278_0312( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0283_0292( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      ((Cla_0225_0227)oHandler.Owner).Function_1035( oHandler );
    }

    public override void AtMyExit( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1036( oHandler );
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 312:
        Tra_0278_0312( oHandler );
        break;
      case 307: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 292:
        Tra_0283_0292( oHandler );
        break;
      case 306: // UP: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >)
  public class Reg_0277_0278 : TsmRegion
  {
    private Ini_0278_0279 oIni_0278_0279; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> InitialState )
    private Jun_0278_0280 oJun_0278_0280; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> JuncState )
    private Cho_0278_0281 oCho_0278_0281; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )
    private Com_0278_0282 oCom_0278_0282; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Sensing )
    private Com_0278_0293 oCom_0278_0293; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling )

    public Reg_0277_0278( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0278_0279 = new Ini_0278_0279( this );
      oJun_0278_0280 = new Jun_0278_0280( this );
      oCho_0278_0281 = new Cho_0278_0281( this );
      oCom_0278_0282 = new Com_0278_0282( this );
      oCom_0278_0293 = new Com_0278_0293( this );
      mNrStates = 5;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0278_0279;
      mStates[ 1 ] = oJun_0278_0280;
      mStates[ 2 ] = oCho_0278_0281;
      mStates[ 3 ] = oCom_0278_0282;
      mStates[ 4 ] = oCom_0278_0293;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0278_0279.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )
    public void Tra_0278_0308( TsmHandler oHandler )
    {
      mCurrentState = oJun_0278_0280; // At: ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )
    public void Tra_0278_0309( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1032( oHandler );
      mCurrentState = oCho_0278_0281; // At: ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
    public void Tra_0278_0310( TsmHandler oHandler )
    {
      mCurrentState = oCom_0278_0282; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
    public void Tra_0278_0312( TsmHandler oHandler )
    {
      mCurrentState = oCom_0278_0293; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing ) => ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )
    public void Tra_0278_0311( TsmHandler oHandler )
    {
      mCurrentState = oJun_0278_0280; // At: ( AircoFsm > CoolingSubFsm >> Composite >> JuncState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
    public void Tra_0294_0307( TsmHandler oHandler )
    {
      mCurrentState = oCom_0278_0282; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
    public void Tra_0283_0292( TsmHandler oHandler )
    {
      mCurrentState = oCom_0278_0293; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
    public void Tra_0294_0306( TsmHandler oHandler )
    {
      mCurrentState = oCom_0278_0282; // At: ( AircoFsm > CoolingSubFsm >> Composite >> Sensing )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 5:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 228
      case 232:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 11:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 308:
        Tra_0278_0308( oHandler );
        break;
      case 309:
        Tra_0278_0309( oHandler );
        break;
      case 310:
        Tra_0278_0310( oHandler );
        break;
      case 312:
        Tra_0278_0312( oHandler );
        break;
      case 311:
        Tra_0278_0311( oHandler );
        break;
      case 307:
        Tra_0294_0307( oHandler );
        break;
      case 292:
        Tra_0283_0292( oHandler );
        break;
      case 306:
        Tra_0294_0306( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite )
  public class Com_0273_0277 : TsmCompound
  {
    private Reg_0277_0278 oReg_0277_0278; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >)

    public Com_0273_0277( TsmBase oParent )
    {
      TsmName = "Composite";
      TsmParent = oParent;
      oReg_0277_0278 = new Reg_0277_0278( this );
      mRegions.Add( oReg_0277_0278 );
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 314, "( AircoFsm > CoolingSubFsm >> Composite ) => ( AircoFsm > CoolingSubFsm >> OffStopping ) : pp_airco->Off" );
      mTransitions[ 1 ] = new TsmTransition( 316, "( AircoFsm > CoolingSubFsm >> Composite ) => ( AircoFsm > CoolingSubFsm >> Stopping ) : pp_airco->Stop" );
    }

    public void Tra_0273_0313( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void pp_airco___Off( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 314; // pp_airco.Off
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void pp_airco___Stop( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 316; // pp_airco.Stop
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      ((Cla_0225_0227)oHandler.Owner).Function_1030( oHandler );
    }

    public override void AtMyExit( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1031( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 228: // Port pp_airco
        switch ( oHandler.Trigger.Command )
        {
        case 2: // pp_airco___Off
          {
            pp_airco___Off( oHandler );
          }
          break;
        case 7: // pp_airco___Stop
          {
            pp_airco___Stop( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 313:
        Tra_0273_0313( oHandler );
        break;
      case 314: // UP: ( AircoFsm > CoolingSubFsm >> Composite ) => ( AircoFsm > CoolingSubFsm >> OffStopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 316: // UP: ( AircoFsm > CoolingSubFsm >> Composite ) => ( AircoFsm > CoolingSubFsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >)
  public class Reg_0272_0273 : TsmRegion
  {
    private Ini_0273_0274 oIni_0273_0274; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> InitialState )
    private Sub_0273_0275 oSub_0273_0275; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> OffStopping )
    private Sub_0273_0276 oSub_0273_0276; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Stopping )
    private Com_0273_0277 oCom_0273_0277; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite )

    public Reg_0272_0273( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0273_0274 = new Ini_0273_0274( this );
      oSub_0273_0275 = new Sub_0273_0275( this );
      oSub_0273_0276 = new Sub_0273_0276( this );
      oCom_0273_0277 = new Com_0273_0277( this );
      mNrStates = 4;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0273_0274;
      mStates[ 1 ] = oSub_0273_0275;
      mStates[ 2 ] = oSub_0273_0276;
      mStates[ 3 ] = oCom_0273_0277;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0273_0274.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite )
    public void Tra_0273_0313( TsmHandler oHandler )
    {
      mCurrentState = oCom_0273_0277; // At: ( AircoFsm > CoolingSubFsm >> Composite )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite ) => ( AircoFsm > CoolingSubFsm >> OffStopping )
    public void Tra_0273_0314( TsmHandler oHandler )
    {
      mCurrentState = oSub_0273_0275; // At: ( AircoFsm > CoolingSubFsm >> OffStopping )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm > CoolingSubFsm >> Composite ) => ( AircoFsm > CoolingSubFsm >> Stopping )
    public void Tra_0273_0316( TsmHandler oHandler )
    {
      mCurrentState = oSub_0273_0276; // At: ( AircoFsm > CoolingSubFsm >> Stopping )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        case 5:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 228
      case 232:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 11:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 313:
        Tra_0273_0313( oHandler );
        break;
      case 315: // Up: ( AircoFsm > CoolingSubFsm >> OffStopping ) => ( AircoFsm > CoolingSubFsm > ExitOff )
        mCurrentState = null;
        bHigher = true;
        break;
      case 317: // Up: ( AircoFsm > CoolingSubFsm >> Stopping ) => ( AircoFsm > CoolingSubFsm > ExitStop )
        mCurrentState = null;
        bHigher = true;
        break;
      case 314:
        Tra_0273_0314( oHandler );
        break;
      case 316:
        Tra_0273_0316( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm )
  public class Fsm_0233_0272 : TsmFsm
  {
    private Reg_0272_0273 oReg_0272_0273; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >)

    public Fsm_0233_0272( TsmBase oParent )
    {
      TsmName = "CoolingSubFsm";
      TsmParent = oParent;
      oReg_0272_0273 = new Reg_0272_0273( this );
      mRegions.Add( oReg_0272_0273 );
      mNrTransitions = 0;
    }

    public void Tra_0273_0315( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.EXITPOINT;
      oHandler.Index  = 318; // ExitOff
    }

    public void Tra_0273_0317( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1029( oHandler );
      oHandler.Action = TsmHandlerAction.EXITPOINT;
      oHandler.Index  = 319; // ExitStop
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 315:
        Tra_0273_0315( oHandler );
        break;
      case 317:
        Tra_0273_0317( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling )
  public class Sub_0237_0240 : TsmSubFsm
  {
    private Con_0240_0241 oCon_0240_0241; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling > ConnExitRef )
    private Con_0240_0242 oCon_0240_0242; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling > ConnExitRef )

    public Sub_0237_0240( TsmBase oParent )
    {
      TsmName = "Cooling";
      TsmParent = oParent;
      oFsm = new Fsm_0233_0272( this ); // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm )
      oCon_0240_0241 = new Con_0240_0241( this );
      oCon_0240_0242 = new Con_0240_0242( this );
      mNrTransitions = 0;
    }

    public void Tra_0237_0247( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oHandler.Action = TsmHandlerAction.ENTER;
      oFsm.ExecuteHandler( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 319: // UmlConnExit(Ref)
        oCon_0240_0241.Initial( oHandler );
        break;
      case 318: // UmlConnExit(Ref)
        oCon_0240_0242.Initial( oHandler );
        break;
      case 248: // UP: ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 249: // UP: ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 247:
        Tra_0237_0247( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Idle )
  public class Lea_0237_0243 : TsmLeaf
  {
    public Lea_0237_0243( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 250, "( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > FinalState ) : pp_airco->Off" );
      mTransitions[ 1 ] = new TsmTransition( 244, "( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Idle ) : pp_airco->GetTarget" );
      mTransitions[ 2 ] = new TsmTransition( 246, "( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Idle ) : pp_airco->SetTarget" );
      mTransitions[ 3 ] = new TsmTransition( 247, "( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Cooling ) : pp_airco->Start" );
    }

    public void Tra_0237_0245( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0237_0248( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void pp_airco___Off( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 250; // pp_airco.Off
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0237_0244( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1068( oHandler );
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void pp_airco___GetTarget( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 244; // pp_airco.GetTarget
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public void Tra_0237_0246( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1071( oHandler );
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void pp_airco___SetTarget( int Target, TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 246; // pp_airco.SetTarget
      oHandler.bTaken = true;
      mTransitions[ 2 ].bVisit = true;
    }

    public void pp_airco___Start( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 247; // pp_airco.Start
      oHandler.bTaken = true;
      mTransitions[ 3 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        case 4:
          return TsmProspect.OK;
        case 5:
          return TsmProspect.OK;
        case 6:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 228: // Port pp_airco
        switch ( oHandler.Trigger.Command )
        {
        case 2: // pp_airco___Off
          {
            pp_airco___Off( oHandler );
          }
          break;
        case 4: // pp_airco___GetTarget
          {
            pp_airco___GetTarget( oHandler );
          }
          break;
        case 5: // pp_airco___SetTarget
          {
            TsmTrigger_IAirco___SetTarget lTrigger = (TsmTrigger_IAirco___SetTarget) oHandler.Trigger;

            pp_airco___SetTarget( lTrigger.Target, oHandler );
          }
          break;
        case 6: // pp_airco___Start
          {
            pp_airco___Start( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 245:
        Tra_0237_0245( oHandler );
        break;
      case 248:
        Tra_0237_0248( oHandler );
        break;
      case 250: // UP: ( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > FinalState )
        bHigher = true;
        break;
      case 244:
        Tra_0237_0244( oHandler );
        break;
      case 246:
        Tra_0237_0246( oHandler );
        break;
      case 247: // UP: ( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Cooling )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler )
  public class Reg_0236_0237 : TsmRegion
  {
    private Ini_0237_0238 oIni_0237_0238; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > InitialState )
    private Fin_0237_0239 oFin_0237_0239; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > FinalState )
    private Sub_0237_0240 oSub_0237_0240; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Cooling )
    private Lea_0237_0243 oLea_0237_0243; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler > Idle )

    public Reg_0236_0237( TsmBase oParent )
    {
      TsmName = "Cooler";
      TsmParent = oParent;
      oIni_0237_0238 = new Ini_0237_0238( this );
      oFin_0237_0239 = new Fin_0237_0239( this );
      oSub_0237_0240 = new Sub_0237_0240( this );
      oLea_0237_0243 = new Lea_0237_0243( this );
      mNrStates = 4;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0237_0238;
      mStates[ 1 ] = oFin_0237_0239;
      mStates[ 2 ] = oSub_0237_0240;
      mStates[ 3 ] = oLea_0237_0243;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0237_0238.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Cooler > InitialState ) => ( AircoFsm >> Active > Cooler > Idle )
    public void Tra_0237_0245( TsmHandler oHandler )
    {
      mCurrentState = oLea_0237_0243; // At: ( AircoFsm >> Active > Cooler > Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > Idle )
    public void Tra_0237_0248( TsmHandler oHandler )
    {
      mCurrentState = oLea_0237_0243; // At: ( AircoFsm >> Active > Cooler > Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Cooler > Cooling > ConnExitRef ) => ( AircoFsm >> Active > Cooler > FinalState )
    public void Tra_0237_0249( TsmHandler oHandler )
    {
      mCurrentState = oFin_0237_0239; // At: ( AircoFsm >> Active > Cooler > FinalState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > FinalState )
    public void Tra_0237_0250( TsmHandler oHandler )
    {
      mCurrentState = oFin_0237_0239; // At: ( AircoFsm >> Active > Cooler > FinalState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Cooling )
    public void Tra_0237_0247( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1072( oHandler );
      mCurrentState = oSub_0237_0240; // At: ( AircoFsm >> Active > Cooler > Cooling )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        case 4:
          return TsmProspect.OK;
        case 5:
          return TsmProspect.OK;
        case 6:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 228
      case 232:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 11:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 245:
        Tra_0237_0245( oHandler );
        break;
      case 248:
        Tra_0237_0248( oHandler );
        break;
      case 249:
        Tra_0237_0249( oHandler );
        break;
      case 250:
        Tra_0237_0250( oHandler );
        break;
      case 247:
        Tra_0237_0247( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > InitialState )
  public class Ini_0251_0252 : TsmPseudo
  {
    public Ini_0251_0252( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 262, "( AircoFsm >> Active > Fan > InitialState ) => ( AircoFsm >> Active > Fan > ReportLevel )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 262; // TRLS ( AircoFsm >> Active > Fan > InitialState ) => ( AircoFsm >> Active > Fan > ReportLevel )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 262: // UP: ( AircoFsm >> Active > Fan > InitialState ) => ( AircoFsm >> Active > Fan > ReportLevel )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > FinalState )
  public class Fin_0251_0253 : TsmFinal
  {
    public Fin_0251_0253( TsmBase oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public void Tra_0251_0263( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0251_0267( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 263:
        Tra_0251_0263( oHandler );
        break;
      case 267:
        Tra_0251_0267( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > ChoiceState )
  public class Cho_0251_0254 : TsmPseudo
  {
    public Cho_0251_0254( TsmBase oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 266, "( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> Low )" );
      mTransitions[ 1 ] = new TsmTransition( 265, "( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> High )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      if ( ((Cla_0225_0227)oHandler.Owner).Guard_1019() )
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 266; // TRLS ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> Low )
        mTransitions[ 0 ].bVisit = true;
      }
      else
      {
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 265; // TRLS ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> High )
        mTransitions[ 1 ].bVisit = true;
      }
    }

    public void Tra_0251_0264( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 266: // UP: ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> Low )
        bHigher = true;
        break;
      case 265: // UP: ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> High )
        bHigher = true;
        break;
      case 264:
        Tra_0251_0264( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> Low )
  public class Lea_0256_0257 : TsmLeaf
  {
    public Lea_0256_0257( TsmBase oParent )
    {
      TsmName = "Low";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 259, "( AircoFsm >> Active > Fan > Active >> Low ) => ( AircoFsm >> Active > Fan > Active >> High ) : pp_airco->FanHigh" );
    }

    public void Tra_0251_0266( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0256_0260( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void pp_airco___FanHigh( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 259; // pp_airco.FanHigh
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      ((Cla_0225_0227)oHandler.Owner).Function_1025( oHandler );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1026( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 228: // Port pp_airco
        switch ( oHandler.Trigger.Command )
        {
        case 9: // pp_airco___FanHigh
          {
            pp_airco___FanHigh( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 266:
        Tra_0251_0266( oHandler );
        break;
      case 260:
        Tra_0256_0260( oHandler );
        break;
      case 259: // UP: ( AircoFsm >> Active > Fan > Active >> Low ) => ( AircoFsm >> Active > Fan > Active >> High )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> High )
  public class Lea_0256_0258 : TsmLeaf
  {
    public Lea_0256_0258( TsmBase oParent )
    {
      TsmName = "High";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 260, "( AircoFsm >> Active > Fan > Active >> High ) => ( AircoFsm >> Active > Fan > Active >> Low ) : pp_airco->FanLow" );
    }

    public void Tra_0251_0265( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void pp_airco___FanLow( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 260; // pp_airco.FanLow
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0256_0259( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      ((Cla_0225_0227)oHandler.Owner).Function_1027( oHandler );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1028( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 8:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 228: // Port pp_airco
        switch ( oHandler.Trigger.Command )
        {
        case 8: // pp_airco___FanLow
          {
            pp_airco___FanLow( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 265:
        Tra_0251_0265( oHandler );
        break;
      case 260: // UP: ( AircoFsm >> Active > Fan > Active >> High ) => ( AircoFsm >> Active > Fan > Active >> Low )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 259:
        Tra_0256_0259( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >)
  public class Reg_0255_0256 : TsmRegion
  {
    private Lea_0256_0257 oLea_0256_0257; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> Low )
    private Lea_0256_0258 oLea_0256_0258; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> High )

    public Reg_0255_0256( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oLea_0256_0257 = new Lea_0256_0257( this );
      oLea_0256_0258 = new Lea_0256_0258( this );
      mNrStates = 2;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oLea_0256_0257;
      mStates[ 1 ] = oLea_0256_0258;
    }

     // Down: ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> Low )
    public void Tra_0251_0266( TsmHandler oHandler )
    {
      mCurrentState = oLea_0256_0257; // Down: ( AircoFsm >> Active > Fan > Active >> Low )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // Down: ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> High )
    public void Tra_0251_0265( TsmHandler oHandler )
    {
      mCurrentState = oLea_0256_0258; // Down: ( AircoFsm >> Active > Fan > Active >> High )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Fan > Active >> High ) => ( AircoFsm >> Active > Fan > Active >> Low )
    public void Tra_0256_0260( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1073( oHandler );
      mCurrentState = oLea_0256_0257; // At: ( AircoFsm >> Active > Fan > Active >> Low )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Fan > Active >> Low ) => ( AircoFsm >> Active > Fan > Active >> High )
    public void Tra_0256_0259( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1074( oHandler );
      mCurrentState = oLea_0256_0258; // At: ( AircoFsm >> Active > Fan > Active >> High )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 8:
          return TsmProspect.OK;
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 266:
        Tra_0251_0266( oHandler );
        break;
      case 265:
        Tra_0251_0265( oHandler );
        break;
      case 260:
        Tra_0256_0260( oHandler );
        break;
      case 259:
        Tra_0256_0259( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active )
  public class Com_0251_0255 : TsmCompound
  {
    private Reg_0255_0256 oReg_0255_0256; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >)

    public Com_0251_0255( TsmBase oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0255_0256 = new Reg_0255_0256( this );
      mRegions.Add( oReg_0255_0256 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 263, "( AircoFsm >> Active > Fan > Active ) => ( AircoFsm >> Active > Fan > FinalState ) : pp_airco->Off" );
    }

    public void Tra_0251_0266( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oReg_0255_0256.ExecuteHandler( oHandler );
    }

    public void Tra_0251_0265( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oReg_0255_0256.ExecuteHandler( oHandler );
    }

    public void pp_airco___Off( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 263; // pp_airco.Off
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override void AtMyExit( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1024( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 228: // Port pp_airco
        switch ( oHandler.Trigger.Command )
        {
        case 2: // pp_airco___Off
          {
            pp_airco___Off( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 266:
        Tra_0251_0266( oHandler );
        break;
      case 265:
        Tra_0251_0265( oHandler );
        break;
      case 263: // UP: ( AircoFsm >> Active > Fan > Active ) => ( AircoFsm >> Active > Fan > FinalState )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > ReportLevel )
  public class Lea_0251_0261 : TsmLeaf
  {
    public Lea_0251_0261( TsmBase oParent )
    {
      TsmName = "ReportLevel";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 267, "( AircoFsm >> Active > Fan > ReportLevel ) => ( AircoFsm >> Active > Fan > FinalState ) : pp_airco->Off" );
      mTransitions[ 1 ] = new TsmTransition( 264, "( AircoFsm >> Active > Fan > ReportLevel ) => ( AircoFsm >> Active > Fan > ChoiceState ) : pp_airco->GetLevel" );
    }

    public void Tra_0251_0262( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void pp_airco___Off( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 267; // pp_airco.Off
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void pp_airco___GetLevel( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 264; // pp_airco.GetLevel
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        case 3:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 228: // Port pp_airco
        switch ( oHandler.Trigger.Command )
        {
        case 2: // pp_airco___Off
          {
            pp_airco___Off( oHandler );
          }
          break;
        case 3: // pp_airco___GetLevel
          {
            pp_airco___GetLevel( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 262:
        Tra_0251_0262( oHandler );
        break;
      case 267: // UP: ( AircoFsm >> Active > Fan > ReportLevel ) => ( AircoFsm >> Active > Fan > FinalState )
        bHigher = true;
        break;
      case 264: // UP: ( AircoFsm >> Active > Fan > ReportLevel ) => ( AircoFsm >> Active > Fan > ChoiceState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan )
  public class Reg_0236_0251 : TsmRegion
  {
    private Ini_0251_0252 oIni_0251_0252; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > InitialState )
    private Fin_0251_0253 oFin_0251_0253; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > FinalState )
    private Cho_0251_0254 oCho_0251_0254; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > ChoiceState )
    private Com_0251_0255 oCom_0251_0255; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active )
    private Lea_0251_0261 oLea_0251_0261; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > ReportLevel )

    public Reg_0236_0251( TsmBase oParent )
    {
      TsmName = "Fan";
      TsmParent = oParent;
      oIni_0251_0252 = new Ini_0251_0252( this );
      oFin_0251_0253 = new Fin_0251_0253( this );
      oCho_0251_0254 = new Cho_0251_0254( this );
      oCom_0251_0255 = new Com_0251_0255( this );
      oLea_0251_0261 = new Lea_0251_0261( this );
      mNrStates = 5;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0251_0252;
      mStates[ 1 ] = oFin_0251_0253;
      mStates[ 2 ] = oCho_0251_0254;
      mStates[ 3 ] = oCom_0251_0255;
      mStates[ 4 ] = oLea_0251_0261;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0251_0252.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Fan > InitialState ) => ( AircoFsm >> Active > Fan > ReportLevel )
    public void Tra_0251_0262( TsmHandler oHandler )
    {
      mCurrentState = oLea_0251_0261; // At: ( AircoFsm >> Active > Fan > ReportLevel )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> Low )
    public void Tra_0251_0266( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1021( oHandler );
      mCurrentState = oCom_0251_0255; // At: ( AircoFsm >> Active > Fan > Active )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> High )
    public void Tra_0251_0265( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1023( oHandler );
      mCurrentState = oCom_0251_0255; // At: ( AircoFsm >> Active > Fan > Active )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Fan > Active ) => ( AircoFsm >> Active > Fan > FinalState )
    public void Tra_0251_0263( TsmHandler oHandler )
    {
      mCurrentState = oFin_0251_0253; // At: ( AircoFsm >> Active > Fan > FinalState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Fan > ReportLevel ) => ( AircoFsm >> Active > Fan > FinalState )
    public void Tra_0251_0267( TsmHandler oHandler )
    {
      mCurrentState = oFin_0251_0253; // At: ( AircoFsm >> Active > Fan > FinalState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active > Fan > ReportLevel ) => ( AircoFsm >> Active > Fan > ChoiceState )
    public void Tra_0251_0264( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1066( oHandler );
      mCurrentState = oCho_0251_0254; // At: ( AircoFsm >> Active > Fan > ChoiceState )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        case 3:
          return TsmProspect.OK;
        case 8:
          return TsmProspect.OK;
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 262:
        Tra_0251_0262( oHandler );
        break;
      case 266:
        Tra_0251_0266( oHandler );
        break;
      case 265:
        Tra_0251_0265( oHandler );
        break;
      case 263:
        Tra_0251_0263( oHandler );
        break;
      case 267:
        Tra_0251_0267( oHandler );
        break;
      case 264:
        Tra_0251_0264( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active )
  public class Com_0234_0236 : TsmCompound
  {
    private Reg_0236_0237 oReg_0236_0237; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Cooler )
    private Reg_0236_0251 oReg_0236_0251; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan )

    public Com_0234_0236( TsmBase oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0236_0237 = new Reg_0236_0237( this );
      oReg_0236_0251 = new Reg_0236_0251( this );
      mRegions.Add( oReg_0236_0237 );
      mRegions.Add( oReg_0236_0251 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 271, "( AircoFsm >> Active ) => ( AircoFsm >> Standby )" );
    }

    public override void ExecuteTriggerless( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 271; // TRLS ( AircoFsm >> Active ) => ( AircoFsm >> Standby )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0234_0270( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 271: // UP: ( AircoFsm >> Active ) => ( AircoFsm >> Standby )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 270:
        Tra_0234_0270( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Standby )
  public class Lea_0234_0268 : TsmLeaf
  {
    public Lea_0234_0268( TsmBase oParent )
    {
      TsmName = "Standby";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 270, "( AircoFsm >> Standby ) => ( AircoFsm >> Active ) : pp_airco->On" );
    }

    public void Tra_0234_0269( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0234_0271( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void pp_airco___On( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 270; // pp_airco.On
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 228: // Port pp_airco
        switch ( oHandler.Trigger.Command )
        {
        case 1: // pp_airco___On
          {
            pp_airco___On( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 269:
        Tra_0234_0269( oHandler );
        break;
      case 271:
        Tra_0234_0271( oHandler );
        break;
      case 270: // UP: ( AircoFsm >> Standby ) => ( AircoFsm >> Active )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >)
  public class Reg_0233_0234 : TsmRegion
  {
    private Ini_0234_0235 oIni_0234_0235; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> InitialState )
    private Com_0234_0236 oCom_0234_0236; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active )
    private Lea_0234_0268 oLea_0234_0268; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Standby )

    public Reg_0233_0234( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0234_0235 = new Ini_0234_0235( this );
      oCom_0234_0236 = new Com_0234_0236( this );
      oLea_0234_0268 = new Lea_0234_0268( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0234_0235;
      mStates[ 1 ] = oCom_0234_0236;
      mStates[ 2 ] = oLea_0234_0268;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0234_0235.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> InitialState ) => ( AircoFsm >> Standby )
    public void Tra_0234_0269( TsmHandler oHandler )
    {
      mCurrentState = oLea_0234_0268; // At: ( AircoFsm >> Standby )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Active ) => ( AircoFsm >> Standby )
    public void Tra_0234_0271( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1018( oHandler );
      mCurrentState = oLea_0234_0268; // At: ( AircoFsm >> Standby )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( AircoFsm >> Standby ) => ( AircoFsm >> Active )
    public void Tra_0234_0270( TsmHandler oHandler )
    {
      ((Cla_0225_0227)oHandler.Owner).Function_1065( oHandler );
      mCurrentState = oCom_0234_0236; // At: ( AircoFsm >> Active )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 228:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        case 2:
          return TsmProspect.OK;
        case 3:
          return TsmProspect.OK;
        case 4:
          return TsmProspect.OK;
        case 5:
          return TsmProspect.OK;
        case 6:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        case 8:
          return TsmProspect.OK;
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 228
      case 232:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        case 11:
          return TsmProspect.OK;
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 269:
        Tra_0234_0269( oHandler );
        break;
      case 271:
        Tra_0234_0271( oHandler );
        break;
      case 270:
        Tra_0234_0270( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm )
  public class Fsm_0227_0233 : TsmFsm
  {
    private Reg_0233_0234 oReg_0233_0234; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >)

    public Fsm_0227_0233( TsmBase oParent )
    {
      TsmName = "AircoFsm";
      TsmParent = oParent;
      oReg_0233_0234 = new Reg_0233_0234( this );
      mRegions.Add( oReg_0233_0234 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass )
  public class Cla_0225_0227 : TsmClass
  {
    private Fsm_0227_0233 oFsm_0227_0233; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm )
    private TsmIPort_IAirco TsmPI__pp_airco; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > pp_airco )
    private TsmIPort_ICooler rp_cooler; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_cooler )
    private TsmIPort_IFan rp_fan; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_fan )
    private TsmIPort_INvm rp_nvm; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_nvm )
    private TsmIPort_ISensor rp_sensor; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_sensor )
    private TsmIPort_ICbSensor TsmPI__rp_sensor; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > rp_sensor )
    private TsmPSPort mPSMessager;
    private TsmPCPort mPCMessager;
    private FanLevel Level;
    private int MyTarget;
    private double MyTemp;

    public Cla_0225_0227( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0227_0233 = new Fsm_0227_0233( this );
      TsmPI__pp_airco = new TsmIPort_IAirco( this );
      TsmPI__rp_sensor = new TsmIPort_ICbSensor( this );
      mPSMessager = new TsmPSPort();
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0227_0233;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_airco" :
        return TsmPI__pp_airco;
      case "rp_sensor" :
        return TsmPI__rp_sensor;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "rp_cooler" :
        rp_cooler = (TsmIPort_ICooler) oProvidedInterface;
        rp_cooler.Source = this;
        return;
      case "rp_fan" :
        rp_fan = (TsmIPort_IFan) oProvidedInterface;
        rp_fan.Source = this;
        return;
      case "rp_nvm" :
        rp_nvm = (TsmIPort_INvm) oProvidedInterface;
        rp_nvm.Source = this;
        return;
      case "rp_sensor" :
        rp_sensor = (TsmIPort_ISensor) oProvidedInterface;
        rp_sensor.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0227_0233.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( AircoFsm >> Active ) => ( AircoFsm >> Standby )
    public void Function_1018( TsmHandler oHandler )
    {
      oHandler.Trigger.Ready();
    }

    public bool Guard_1019()
    {
      return Level==FanLevel.LOW;
    }

     // ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> Low )
    public FanLevel Function_1020()
    {
      return FanLevel.LOW;
    }

     // ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> Low )
    public void Function_1021( TsmHandler oHandler )
    {
      TsmTrigger_IAirco___GetLevel lTrigger = (TsmTrigger_IAirco___GetLevel) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0225_0227)oHandler.Owner).Function_1020();

      oHandler.Trigger.Ready();
    }

     // ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> High )
    public FanLevel Function_1022()
    {
      return FanLevel.HIGH;
    }

     // ( AircoFsm >> Active > Fan > ChoiceState ) => ( AircoFsm >> Active > Fan > Active >> High )
    public void Function_1023( TsmHandler oHandler )
    {
      TsmTrigger_IAirco___GetLevel lTrigger = (TsmTrigger_IAirco___GetLevel) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0225_0227)oHandler.Owner).Function_1022();

      oHandler.Trigger.Ready();
    }

     // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active )
    public void Function_1024( TsmHandler oHandler )
    {
      rp_fan.Stop();
    }

     // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> Low )
    public void Function_1025( TsmHandler oHandler )
    {
      rp_fan.ToLow();
    }

     // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> Low )
    public void Function_1026( TsmHandler oHandler )
    {
      rp_nvm.SetFanLevel(FanLevel.LOW);
    }

     // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> High )
    public void Function_1027( TsmHandler oHandler )
    {
      rp_fan.ToHigh();
    }

     // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm >> Active > Fan > Active >> High )
    public void Function_1028( TsmHandler oHandler )
    {
      rp_nvm.SetFanLevel(FanLevel.HIGH);
    }

     // ( AircoFsm > CoolingSubFsm >> Stopping ) => ( AircoFsm > CoolingSubFsm > ExitStop )
    public void Function_1029( TsmHandler oHandler )
    {
      oHandler.Trigger.Ready();
    }

     // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite )
    public void Function_1030( TsmHandler oHandler )
    {
      MyTarget=rp_nvm.GetTarget();
    }

     // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite )
    public void Function_1031( TsmHandler oHandler )
    {
      rp_nvm.SetTarget(MyTarget);
    }

     // ( AircoFsm > CoolingSubFsm >> Composite >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> ChoiceState )
    public void Function_1032( TsmHandler oHandler )
    {
      MyTemp=rp_sensor.GetTemperature();
    }

    public bool Guard_1033()
    {
      return MyTemp<=MyTarget;
    }

     // ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> InitialState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait )
    public void Function_1034( TsmHandler oHandler )
    {
      rp_sensor.SignalAbove(MyTarget);
    }

     // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling )
    public void Function_1035( TsmHandler oHandler )
    {
      rp_cooler.Start();
    }

     // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoClass > AircoFsm > CoolingSubFsm >> Composite >> Cooling )
    public void Function_1036( TsmHandler oHandler )
    {
      rp_cooler.Stop();
    }

     // ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> JuncState ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait )
    public void Function_1037( TsmHandler oHandler )
    {
      rp_sensor.SignalBelow(MyTarget-1);
    }

    public bool Guard_1038()
    {
      return MyTemp<=MyTarget;
    }

     // ( AircoFsm > StoppingSubFsm >> InitialState ) => ( AircoFsm > StoppingSubFsm >> Wait )
    public void Function_1039( TsmHandler oHandler )
    {
      rp_sensor.Stop();
    }

     // ( AircoFsm >> Standby ) => ( AircoFsm >> Active )
    public void Function_1065( TsmHandler oHandler )
    {
      oHandler.Trigger.Ready();
    }

     // ( AircoFsm >> Active > Fan > ReportLevel ) => ( AircoFsm >> Active > Fan > ChoiceState )
    public void Function_1066( TsmHandler oHandler )
    {
      Level=rp_nvm.GetFanLevel();
    }

     // ( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Idle )
    public int Function_1067()
    {
      return rp_nvm.GetTarget();
    }

     // ( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Idle )
    public void Function_1068( TsmHandler oHandler )
    {
      TsmTrigger_IAirco___GetTarget lTrigger = (TsmTrigger_IAirco___GetTarget) oHandler.Trigger;

      lTrigger._RetVal = ((Cla_0225_0227)oHandler.Owner).Function_1067();

      oHandler.Trigger.Ready();
    }

     // ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping )
    public void Function_1069( TsmHandler oHandler )
    {
      TsmTrigger_IAirco___SetTarget lTrigger = (TsmTrigger_IAirco___SetTarget) oHandler.Trigger;
      int Target = lTrigger.Target;

      MyTarget=Target;
      rp_sensor.Stop();
    }

     // ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Wait ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping )
    public void Function_1070( TsmHandler oHandler )
    {
      TsmTrigger_IAirco___SetTarget lTrigger = (TsmTrigger_IAirco___SetTarget) oHandler.Trigger;
      int Target = lTrigger.Target;

      MyTarget=Target;
      rp_sensor.Stop();
    }

     // ( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Idle )
    public void Function_1071( TsmHandler oHandler )
    {
      TsmTrigger_IAirco___SetTarget lTrigger = (TsmTrigger_IAirco___SetTarget) oHandler.Trigger;
      int Target = lTrigger.Target;

      rp_nvm.SetTarget( Target );
      oHandler.Trigger.Ready();
    }

     // ( AircoFsm >> Active > Cooler > Idle ) => ( AircoFsm >> Active > Cooler > Cooling )
    public void Function_1072( TsmHandler oHandler )
    {
      oHandler.Trigger.Ready();
    }

     // ( AircoFsm >> Active > Fan > Active >> High ) => ( AircoFsm >> Active > Fan > Active >> Low )
    public void Function_1073( TsmHandler oHandler )
    {
      oHandler.Trigger.Ready();
    }

     // ( AircoFsm >> Active > Fan > Active >> Low ) => ( AircoFsm >> Active > Fan > Active >> High )
    public void Function_1074( TsmHandler oHandler )
    {
      oHandler.Trigger.Ready();
    }

     // ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Sensing >> FinalState )
    public void Function_1075( TsmHandler oHandler )
    {
      oHandler.Trigger.Ready();
    }

     // ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> Stopping ) => ( AircoFsm > CoolingSubFsm >> Composite >> Cooling >> ChoiceState )
    public void Function_1076( TsmHandler oHandler )
    {
      MyTemp=rp_sensor.GetTemperature();
      oHandler.Trigger.Ready();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__pp_airco.PortId = 228;
      TsmPI__pp_airco.Messager = mPSMessager;
      TsmPI__rp_sensor.PortId = 232;
      TsmPI__rp_sensor.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0227_0233.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Repository > AircoPackage > AircoComponent )
  public class Com_0224_0225 : TsmAComponent
  {
    private Cla_0225_0227 AircoInstance; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > AircoInstance )
    private TsmIPort_IAirco TsmPI__d_pp_airco; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > d_pp_airco )
    private TsmASPort TsmMr__d_pp_airco;
    private TsmIPort_ICbSensor TsmPI__d_rp_sensor; // ( Xmi > Data > Repository > AircoPackage > AircoComponent > d_rp_sensor )
    private TsmACPort TsmMr__d_rp_sensor;

    public Com_0224_0225( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      AircoInstance = new Cla_0225_0227( this, "AircoInstance" );
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = AircoInstance;
      TsmPI__d_pp_airco = new TsmIPort_IAirco( this );
      TsmMr__d_pp_airco = new TsmASPort();
      TsmPI__d_rp_sensor = new TsmIPort_ICbSensor( this );
      TsmMr__d_rp_sensor = new TsmACPort();
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_pp_airco" :
        return TsmPI__d_pp_airco;
      case "d_rp_sensor" :
        return TsmPI__d_rp_sensor;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > AircoPackage > AircoComponent )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_rp_cooler" :
        AircoInstance.SetRequiredInterface( "rp_cooler", oProvidedInterface );
        return;
      case "d_rp_fan" :
        AircoInstance.SetRequiredInterface( "rp_fan", oProvidedInterface );
        return;
      case "d_rp_nvm" :
        AircoInstance.SetRequiredInterface( "rp_nvm", oProvidedInterface );
        return;
      case "d_rp_sensor" :
        AircoInstance.SetRequiredInterface( "rp_sensor", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > AircoPackage > AircoComponent )";
      throw new TsmException( s );
    }

    public override void TsmInitialise( object oObject )
    {
      base.TsmInitialise( oObject );
      TsmMr__d_pp_airco.Thread = Thread;
      TsmPI__d_pp_airco.Messager = TsmMr__d_pp_airco;
      TsmMr__d_rp_sensor.Thread = Thread;
      TsmPI__d_rp_sensor.Messager = TsmMr__d_rp_sensor;
    }

    public override void TsmConnect( object oObject )
    {
      TsmInterfacePort ClassPort;
      ClassPort = AircoInstance.GetProvidedInterface( "pp_airco" );
      TsmPI__d_pp_airco.PortId = ClassPort.PortId;
      TsmMr__d_pp_airco.Target = ClassPort.Messager.Target;
      ClassPort = AircoInstance.GetProvidedInterface( "rp_sensor" );
      TsmPI__d_rp_sensor.PortId = ClassPort.PortId;
      TsmMr__d_rp_sensor.Target = ClassPort.Messager.Target;
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv > Fan )
  public class Com_0209_0001 : TsmPComponent
  {
    private Cla_0155_0156 InsFanServer; // ( Xmi > Data > Protocols > FanProtocol > FanServer > InsFanServer )

    public Com_0209_0001( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsFanServer = new Cla_0155_0156( this, "InsFanServer" );
      InsFanServer.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsFanServer;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_fan" :
        return InsFanServer.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Fan )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv > Cooler )
  public class Com_0209_0003 : TsmPComponent
  {
    private Cla_0134_0135 InsCoolerServer; // ( Xmi > Data > Protocols > CoolerProtocol > CoolerServer > InsCoolerServer )

    public Com_0209_0003( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCoolerServer = new Cla_0134_0135( this, "InsCoolerServer" );
      InsCoolerServer.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsCoolerServer;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_cooler" :
        return InsCoolerServer.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Cooler )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv > Nvm )
  public class Com_0209_0005 : TsmPComponent
  {
    private Cla_0188_0191 InsNvmServer; // ( Xmi > Data > Protocols > NvmProtocol > NvmServer > InsNvmServer )

    public Com_0209_0005( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsNvmServer = new Cla_0188_0191( this, "InsNvmServer" );
      InsNvmServer.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsNvmServer;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_nvm" :
        return InsNvmServer.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Nvm )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv > Ui )
  public class Com_0209_0007 : TsmPComponent
  {
    private Cla_0003_0039 InsAircoClient; // ( Xmi > Data > Protocols > AircoProtocol > AircoClient > InsAircoClient )

    public Com_0209_0007( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsAircoClient = new Cla_0003_0039( this, "InsAircoClient" );
      InsAircoClient.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsAircoClient;
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "rp_airco" :
        InsAircoClient.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Ui )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv > Sensor )
  public class Com_0209_0009 : TsmPComponent
  {
    private Cla_0074_0102 InsSensorServer; // ( Xmi > Data > Protocols > SensorProtocol > SensorServer > InsSensorServer )

    public Com_0209_0009( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsSensorServer = new Cla_0074_0102( this, "InsSensorServer" );
      InsSensorServer.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsSensorServer;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_sensor" :
        return InsSensorServer.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Sensor )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_sensor" :
        InsSensorServer.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv > Sensor )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv )
  public class Com_0208_0209 : TsmPComponent
  {
    private Com_0224_0225 Airco; // ( Xmi > Data > Architecture > ExecEnv > Airco )
    private Com_0209_0001 Fan; // ( Xmi > Data > Architecture > ExecEnv > Fan )
    private Com_0209_0003 Cooler; // ( Xmi > Data > Architecture > ExecEnv > Cooler )
    private Com_0209_0005 Nvm; // ( Xmi > Data > Architecture > ExecEnv > Nvm )
    private Com_0209_0007 Ui; // ( Xmi > Data > Architecture > ExecEnv > Ui )
    private Com_0209_0009 Sensor; // ( Xmi > Data > Architecture > ExecEnv > Sensor )

    public Com_0208_0209( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Airco = new Com_0224_0225( this, "Airco" );
      Fan = new Com_0209_0001( this, "Fan" );
      Cooler = new Com_0209_0003( this, "Cooler" );
      Nvm = new Com_0209_0005( this, "Nvm" );
      Ui = new Com_0209_0007( this, "Ui" );
      Sensor = new Com_0209_0009( this, "Sensor" );
      mNrComponents = 6;
      mComponents = new TsmComponent[ 6 ];
      mComponents[ 0 ] = Airco;
      mComponents[ 1 ] = Fan;
      mComponents[ 2 ] = Cooler;
      mComponents[ 3 ] = Nvm;
      mComponents[ 4 ] = Ui;
      mComponents[ 5 ] = Sensor;
    }

    public override void TsmConnect( object oObject )
    {
      DoAssembly( Airco, "d_rp_cooler", Cooler, "pp_cooler" );
      DoAssembly( Airco, "d_rp_nvm", Nvm, "pp_nvm" );
      DoAssembly( Ui, "rp_airco", Airco, "d_pp_airco" );
      DoAssembly( Airco, "d_rp_sensor", Sensor, "pp_sensor" );
      DoAssembly( Sensor, "pp_sensor", Airco, "d_rp_sensor" );
      DoAssembly( Airco, "d_rp_fan", Fan, "pp_fan" );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture > Sequence Diagrams )
   ********************************************************************/

   // ( Xmi > Data > Architecture > Sequence Diagrams )
  public class Pac_0208_0216 : TsmPackage
  {
    public Pac_0208_0216( TsmBase oParent )
    {
      TsmName = "Sequence Diagrams";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture )
   ********************************************************************/

   // ( Xmi > Data > Architecture )
  public class Pac_0001_0208 : TsmPackage
  {
    public Pac_0001_0208( TsmBase oParent )
    {
      TsmName = "Architecture";
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > CoolerComponent )
  public class Com_0218_0219 : TsmPComponent
  {
    public Com_0218_0219( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > NvmComponent )
  public class Com_0218_0220 : TsmPComponent
  {
    public Com_0218_0220( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > FanComponent )
  public class Com_0218_0221 : TsmPComponent
  {
    public Com_0218_0221( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > SensorComponent )
  public class Com_0218_0222 : TsmPComponent
  {
    public Com_0218_0222( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > UiComponent )
  public class Com_0218_0223 : TsmPComponent
  {
    public Com_0218_0223( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Terminators )
   ********************************************************************/

   // ( Xmi > Data > Repository > Terminators )
  public class Pac_0217_0218 : TsmPackage
  {
    public Pac_0217_0218( TsmBase oParent )
    {
      TsmName = "Terminators";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > AircoPackage )
   ********************************************************************/

   // ( Xmi > Data > Repository > AircoPackage )
  public class Pac_0217_0224 : TsmPackage
  {
    public Pac_0217_0224( TsmBase oParent )
    {
      TsmName = "AircoPackage";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository )
   ********************************************************************/

   // ( Xmi > Data > Repository )
  public class Pac_0001_0217 : TsmPackage
  {
    public Pac_0001_0217( TsmBase oParent )
    {
      TsmName = "Repository";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > TypeDefinitions )
   ********************************************************************/

   // ( Xmi > Data > TypeDefinitions )
  public class Pac_0001_0329 : TsmPackage
  {
    public Pac_0001_0329( TsmBase oParent )
    {
      TsmName = "TypeDefinitions";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > TismStereotypes )
   ********************************************************************/

   // ( Xmi > Data > TismStereotypes )
  public class Pac_0001_0330 : TsmPackage
  {
    public Pac_0001_0330( TsmBase oParent )
    {
      TsmName = "TismStereotypes";
      TsmParent = oParent;
    }
  }

   // ( Xmi )
  public class TsmSystem : TsmExecComponent
  {
    private Com_0208_0209 ExecEnv; // ( Xmi > Data > Architecture > ExecEnv )

    public TsmSystem( TsmBase oParent )
    {
      TsmName = "Xmi";
      TsmParent = oParent;
      mNrComponents = 1;
      mComponents = new TsmComponent[ 1 ];
      ExecEnv = new Com_0208_0209( null, "ExecEnv" );
      mComponents[ 0 ] = ExecEnv;
    }
  }
}
